/*
    Copyright (C) 2007 Malignant Manor

    This file is part of SI BG Merge.

    SI BG Merge is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    SI BG Merge is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SI BG Merge.  If not, see <http://www.gnu.org/licenses/>.

    Author: Malignant Manor
    All of the functions except SpellScroll and Spellbook are heavily modified versions
    of the keyring class code and related functions written by Marzo Sette Torres Junior
    Last Modified: 2008-09-13
*/

class Spellbook_data
{
	var spells;

	var in_spellbook (var target)
	{
		return (target in spells);
	}
	var add_to_spellbook (var spellbook, var spell)
	{
		var qual = spell->get_item_quality();
		if (!in_spellbook(qual) && qual <= HighestSpellbookQuality)
		{
                        // Add the spell to the spellbook:
			spells << qual;
			// Delete the spell from the world:
			spell->remove_item();
			return true;
		}
                else if (!in_spellbook(qual -170) && qual >= 170 &&  qual <= HighestSpellbookQuality + 170)
		{
		        // Add the spell to the spellbook:
			spells << qual -170;
			// Delete the spell from the world:
			spell->remove_item();
			return true;
		}
		else if (in_spellbook(qual) || in_spellbook(qual -170))
		{
                        AVATAR.say("We already have that spell in the spellbook");
                        return false;
                }
		else if (qual > HighestSpellbookQuality || qual > HighestSpellbookQuality + 170)
		{
                        AVATAR.say("We cannot add that scroll into the spellbook");
                        return false;
                }
                else
                        AVATAR.say("Error");
	}

	dump_spells ()
	{
		// Create a bag for the spells:
		var bag = UI_create_new_object(SHAPE_BAG);
		for (spell in spells)
		{
			// Create the spells:
			var spellobj = UI_create_new_object(NEWSPELLSCROLL);
			spellobj->set_item_frame(spell % 7);
			// Set their qualities:
			spellobj->set_item_quality(spell);
			// Place the spells in the bag:
			bag->give_last_created();
		}
		// Place the bag at the avatar's feet:
		UI_update_last_created(AVATAR->get_object_position());
		// Clear the spellbook collection:
		spells = [];
	}
	
	var remove_scroll (var qual)
        {
		// Create the scroll:
		var spellobj = UI_create_new_object(NEWSPELLSCROLL);
		spellobj->set_item_frame(UI_die_roll(0, 7));
		// Set its quality:
		spellobj->set_item_quality(qual);
		// Place the scroll at the avatar's feet:
		UI_update_last_created(AVATAR->get_object_position());
		// Clear the spell from the spellbook:
                var newspells = [];
                for (spell in spells)
                if (spell != qual)
                newspells << spell;
                spells = newspells;
        }

	var add_party_spells (var spellbook)
	{
		//Count party spells:
		var oldsize = UI_get_array_size(spells);
		var party = UI_get_party_list();
		for (npc in party)
		{
			//For each party member, get contained spells
                        var spell_coll = npc->get_cont_items(NEWSPELLSCROLL, QUALITY_ANY, FRAME_ANY);
			for (spell in spell_coll)
			{
				//For each spell found, get spell quality:
				var qual = spell->get_item_quality();

					//Add spell to spellbook:
					if (!in_spellbook(qual) && qual <= HighestSpellbookQuality)
		                        {
                                                // Add the spell to the spellbook:
			                        spells << qual;
			                        // Delete the spell from the world:
			                        spell->remove_item();
		                         }
                                         if (!in_spellbook(qual -170) && qual >= 170 &&  qual <= HighestSpellbookQuality + 170)
		                         {
		                                // Add the spell to the spellbook:
			                        spells << qual -170;
			                        // Delete the spell from the world:
			                        spell->remove_item();
		                         }
                        }
		}
		return UI_get_array_size(spells);
	}
}

class<Spellbook_data> get_spellbook ()
{
	//This stores the spells in the spellbook:
	static class<Spellbook_data> spellbook;
	static var initialized;
	if (!initialized)
	{
		spellbook = new Spellbook_data([]);
		initialized = true;
	}
	return spellbook;
}

class Spellbook_data2
{
	var spells2;

	var in_spellbook2 (var target)
	{
		return (target in spells2);
	}
	var add_to_spellbook2 (var spellbook2, var spell)
	{
		var qual = spell->get_item_quality();
		if (!in_spellbook2(qual) && qual <= HighestSpellbookQuality)
		{
                        // Add the spell to the spellbook:
			spells2 << qual;
			// Delete the spell from the world:
			spell->remove_item();
			return true;
		}
                else if (!in_spellbook2(qual -170) && qual >=170 &&  qual <= HighestSpellbookQuality + 170)
		{
		        // Add the spell to the spellbook:
			spells2 << qual -170;
			// Delete the spell from the world:
			spell->remove_item();
			return true;
		}
		else if (in_spellbook2(qual) || in_spellbook2(qual -170))
		{
                        AVATAR.say("We already have that spell in the spellbook");
                        return false;
                }
		else if (qual > HighestSpellbookQuality || qual > HighestSpellbookQuality + 170)
		{
                        AVATAR.say("We cannot add that scroll into the spellbook");
                        return false;
                }
                else
                        AVATAR.say("Error");
	}

	dump_spells2 ()
	{
		// Create a bag for the spells:
		var bag = UI_create_new_object(SHAPE_BAG);
		for (spell in spells2)
		{
			// Create the spells:
			var spellobj = UI_create_new_object(NEWSPELLSCROLL);
			spellobj->set_item_frame(spell % 7);
			// Set their qualities:
			spellobj->set_item_quality(spell);
			// Place the spells in the bag:
			bag->give_last_created();
		}
		// Place the bag at the avatar's feet:
		UI_update_last_created(AVATAR->get_object_position());
		// Clear the spellbook collection:
		spells2 = [];
	}

        var remove_scroll2 (var qual)
        {
		// Create the scroll:
		var spellobj = UI_create_new_object(NEWSPELLSCROLL);
		spellobj->set_item_frame(UI_die_roll(0, 7));
		// Set its quality:
		spellobj->set_item_quality(qual);
		// Place the scroll at the avatar's feet:
		UI_update_last_created(AVATAR->get_object_position());
		// Clear the spell from the spellbook:
                var newspells = [];
                for (spell in spells2)
                if (spell != qual)
                newspells << spell;
                spells2 = newspells;
        }

	var add_party_spells2 (var spellbook2)
	{
		//Count party spells:
		var oldsize = UI_get_array_size(spells2);
		var party = UI_get_party_list();
		for (npc in party)
		{
			//For each party member, get contained spells
			var spell_coll = npc->get_cont_items(NEWSPELLSCROLL, QUALITY_ANY, FRAME_ANY);
			for (spell in spell_coll)
			{
				//For each spell found, get spell quality:
				var qual = spell->get_item_quality();

					//Add spell to spellbook:
					if (!in_spellbook2(qual) && qual <= HighestSpellbookQuality)
		                        {
                                                //Add spell to spellbook:
			                        spells2 << qual;
			                        //Remove spell:
			                        spell->remove_item();
		                         }
                                         if (!in_spellbook2(qual -170) && qual >= 170 &&  qual <= HighestSpellbookQuality + 170)
		                         {
		                                //Add spell to spellbook:
			                        spells2 << qual -170;
			                        //Remove spell:
			                        spell->remove_item();
		                         }
			}
		}
		return UI_get_array_size(spells2);
	}
} 

class<Spellbook_data2> get_spellbook2 ()
{
	//This stores the spells in the spellbook:
	static class<Spellbook_data2> spellbook2;
	static var initialized;
	if (!initialized)
	{
		spellbook2 = new Spellbook_data2([]);
		initialized = true;
	}
	return spellbook2;
}

AddScrollFromBook object#()()
{
        var target = UI_click_on_item();
        var quality = get_item_quality();

        if (target->is_npc()) // Using the spellbook on an npc adds all scrolls in the party to the spellbook.
	{
                if (quality == 5)
                        get_spellbook()->add_party_spells(item);
                else if (quality == 6)
                        get_spellbook2()->add_party_spells2(item);
        }
	else if (target->get_item_shape() == NEWSPELLSCROLL) // Add the targeted scroll to the spellbook
	{
                if (quality == 5)
                        get_spellbook()->add_to_spellbook(item, target);
                else if (quality == 6)
                        get_spellbook2()->add_to_spellbook2(item, target);
        }
        return;
}

Remove_a_scroll object#() ()
{
    var qual;
    var caster_face;
    var shape = get_item_shape();
    var frame = get_item_frame();
    var quality = get_item_quality();
    var find_SI_spellbook = UI_find_object(PARTY, 761, QUALITY_ANY, FRAME_ANY);

    if (UI_is_readied(AVATAR, WEAPON_HAND , shape, frame) && UI_get_cont_items(AVATAR, shape, quality, frame))
        caster_face = AVATAR;
    else if ((UI_is_readied(IOLO, WEAPON_HAND , shape, frame) && UI_get_cont_items(IOLO, shape, quality, frame)) // SI Counterpart
          || (UI_is_readied(IOLO_BG, WEAPON_HAND , shape, frame) && UI_get_cont_items(IOLO_BG, shape, quality, frame))) // BG Counterpart
        caster_face = IOLO_FACE;
    else if ((UI_is_readied(SHAMINO, WEAPON_HAND , shape, frame) && UI_get_cont_items(SHAMINO, shape, quality, frame)) // SI Counterpart
          || (UI_is_readied(SHAMINO_BG, WEAPON_HAND , shape, frame) && UI_get_cont_items(SHAMINO_BG, shape, quality, frame))) // BG Counterpart
        caster_face = SHAMINO_FACE;
    else if ((UI_is_readied(DUPRE, WEAPON_HAND , shape, frame) && UI_get_cont_items(DUPRE, shape, quality, frame)) // SI Counterpart
          || (UI_is_readied(DUPRE_BG, WEAPON_HAND , shape, frame) && UI_get_cont_items(DUPRE_BG, shape, quality, frame))) // BG Counterpart
        caster_face = DUPRE_FACE;
    else if (UI_is_readied(GWENNO, WEAPON_HAND , shape, frame) && UI_get_cont_items(GWENNO, shape, quality, frame))
        caster_face = GWENNO;
//BG Companions
    else if (UI_is_readied(JAANA, WEAPON_HAND , shape, frame) && UI_get_cont_items(JAANA, shape, quality, frame))
        caster_face = JAANA_FACE;
    else if (UI_is_readied(JULIA_BG, WEAPON_HAND , shape, frame) && UI_get_cont_items(JULIA_BG, shape, quality, frame))
        caster_face = JULIA_BG_FACE;
    else if (UI_is_readied(LAURIANNA, WEAPON_HAND , shape, frame) && UI_get_cont_items(LAURIANNA, shape, quality, frame))
        caster_face = LAURIANNA_FACE;
    else if (UI_is_readied(MARIAH, WEAPON_HAND , shape, frame) && UI_get_cont_items(MARIAH, shape, quality, frame))
        caster_face = MARIAH_FACE;
    else if (UI_is_readied(TSERAMED, WEAPON_HAND , shape, frame) && UI_get_cont_items(TSERAMED, shape, quality, frame))
        caster_face = TSERAMED_FACE;

   if (quality == 255)
   {
   add(["First", "Second", "Third", "Fourth", "Fifth", "Sixth", "Seventh",
                  "Eighth", "Ninth", "Close book", "Remove all pages"]);
    caster_face.say("");
    converse (0)
    {
        case "First":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 0);
             say("");

             var spells = ["Create food", "Cure", "Detect trap", "Great douse", "Great ignite", "Light", "Locate", "Telekinesis"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index -1))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Create food":
                   qual = 0;
	           break;
                 case "Cure":
                   qual = 1;
	           break;
                 case "Detect trap":
                   qual = 2;
	           break;
                 case "Great douse":
                   qual = 3;
	           break;
                 case "Great ignite":
                   qual = 4;
	           break;
                 case "Light":
                   qual = 5;
	           break;
                 case "Locate":
                   qual = 6;
	           break;
                 case "Telekinesis":
                   qual = 7;
	           break;

        case "Second":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 1);
             say("");

             var spells = ["Awaken", "Destroy trap", "False Coin", "Cold blast", "Great light", "Heal", "Mass cure", "Protection"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 7))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Awaken":
                   qual = 8;
	           break;
                 case "Destroy trap":
                   qual = 9;
	           break;
                 case "False Coin":
                   qual = 10;
	           break;
                 case "Cold blast":
                   qual = 11;
	           break;
                 case "Great light":
                   qual = 12;
	           break;
                 case "Heal":
                   qual = 13;
	           break;
                 case "Mass cure":
                   qual = 14;
	           break;
                 case "Protection":
                   qual = 15;
	           break;

        case "Third":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 2);
             say("");

             var spells = ["Chill", "Curse", "Enchant missiles", "Columna's intuition", "Protect all", "Paralyze", "Sleep", "Translation"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 15))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Chill":
                   qual = 16;
	           break;
                 case "Curse":
                   qual = 17;
	           break;
                 case "Enchant missiles":
                   qual = 18;
	           break;
                 case "Columna's intuition":
                   qual = 19;
	           break;
                 case "Protect all":
                   qual = 20;
	           break;
                 case "Paralyze":
                   qual = 21;
	           break;
                 case "Sleep":
                   qual = 22;
	           break;
                 case "Translation":
                   qual = 23;
	           break;

        case "Fourth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 3);
             say("");

             var spells = ["Blink", "Deter", "Flash", "Create soul prism", "Mass curse", "Reveal", "Transcribe", "Unlock Magic"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 23))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Blink":
                   qual = 24;
	           break;
                 case "Deter":
                   qual = 25;
	           break;
                 case "Flash":
                   qual = 26;
	           break;
                 case "Create soul prism":
                   qual = 27;
	           break;
                 case "Mass curse":
                   qual = 28;
	           break;
                 case "Reveal":
                   qual = 29;
	           break;
                 case "Transcribe":
                   qual = 30;
	           break;
                 case "Unlock Magic":
                   qual = 31;
	           break;

        case "Fifth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 4);
             say("");

             var spells = ["Conjure", "Dispel field", "Explosion", "Great heal", "Invisibility", "Mass sleep", "Summon shade", "Erstam's surprise"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 31))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Conjure":
                   qual = 32;
	           break;
                 case "Dispel field":
                   qual = 33;
	           break;
                 case "Explosion":
                   qual = 34;
	           break;
                 case "Great heal":
                   qual = 35;
	           break;
                 case "Invisibility":
                   qual = 36;
	           break;
                 case "Mass sleep":
                   qual = 37;
	           break;
                 case "Summon shade":
                   qual = 38;
	           break;
                 case "Erstam's surprise":
                   qual = 39;
	           break;

        case "Sixth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 5);
             say("");

             var spells = ["Betray", "Dispel illusion", "Cause fear", "Fire field", "Fire ring", "Cold strike", "Create ammo", "Create Automaton"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 39))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Betray":
                   qual = 40;
	           break;
                 case "Dispel illusion":
                   qual = 41;
	           break;
                 case "Cause fear":
                   qual = 42;
	           break;
                 case "Fire field":
                   qual = 43;
	           break;
                 case "Fire ring":
                   qual = 44;
	           break;
                 case "Cold strike":
                   qual = 45;
	           break;
                 case "Create ammo":
                   qual = 46;
	           break;
                 case "Create Automaton":
                   qual = 47;
	           break;

        case "Seventh":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 6);
             say("");

             var spells = ["Energy field", "Energy mist", "Mass awaken", "Mass might", "Poison mist", "Restoration", "Vibrate", "Lightning"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 47))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Energy field":
                   qual = 48;
	           break;
                 case "Energy mist":
                   qual = 49;
	           break;
                 case "Mass awaken":
                   qual = 50;
	           break;
                 case "Mass might":
                   qual = 51;
	           break;
                 case "Poison mist":
                   qual = 52;
	           break;
                 case "Restoration":
                   qual = 53;
	           break;
                 case "Vibrate":
                   qual = 54;
	           break;
                 case "Lightning":
                   qual = 55;
	           break;

        case "Eighth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 7);
             say("");

             var spells = ["Create ice", "Mind blast", "Delayed blast", "Fetch", "Invoke snow serpent", "Serpent bond", "Fire snake", "Swordstrike" ];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 55))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Create ice":
                   qual = 56;
	           break;
                 case "Mind blast":
                   qual = 57;
	           break;
                 case "Delayed blast":
                   qual = 58;
	           break;
                 case "Fetch":
                   qual = 59;
	           break;
                 case "Invoke snow serpent":
                   qual = 60;
	           break;
                 case "Serpent bond":
                   qual = 61;
	           break;
                 case "Fire snake":
                   qual = 62;
	           break;
                 case "Swordstrike":
                   qual = 63;
	           break;

        case "Ninth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 8);
             say("");

             var spells = ["Death vortex", "Mass death", "Invisible all", "Spiral missile", "Stop storm", "Summon", "Time stop", "Imbalance"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 63))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Death vortex":
                   qual = 64;
	           break;
                 case "Mass death":
                   qual = 65;
	           break;
                 case "Invisibility all":
                   qual = 66;
	           break;
                 case "Spiral missile":
                   qual = 67;
	           break;
                 case "Stop storm":
                   qual = 68;
	           break;
                 case "Summon":
                   qual = 69;
	           break;
                 case "Time stop":
                   qual = 70;
	           break;
                 case "Imbalance":
                   qual = 71;
	           break;

        case "Choose another spell":
             UI_clear_answers();
             UI_pop_answers();
             UI_remove_npc_face(SPELLBOOK_FACE);
             caster_face.say("");

        case "Remove all pages": // Dumps all the scroll from the spellbook into a bag at the Avatar's feet..
        {
                caster_face.say("@Should I remove ALL the spells from the spellbook?@");
                if (askYesNo())
                {
                        // Create a bag for the spells:
		var bag = UI_create_new_object(SHAPE_BAG);
                var qual = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
                            21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
                            41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60,
                            61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71];
                for (spell in qual with index)
		{
			if (UI_has_spell(find_SI_spellbook, index - 1))
                        {
                            // Create the spells:
			    var spellobj = UI_create_new_object(SPELLSCROLL);
			    spellobj->set_item_frame(spell % 7);
			    // Set their qualities:
			    spellobj->set_item_quality(spell);
			    // Place the spells in the bag:
			    bag->give_last_created();
			}
		}
		// Place the bag at the avatar's feet:
		UI_update_last_created(AVATAR->get_object_position());
		// Clear the spellbook collection:
		UI_remove_all_spells(find_SI_spellbook);
                }
        }
        case "Close book":
             return;
    }
   }
   else
   {
    add(["Linear", "First", "Second", "Third", "Fourth", "Fifth", "Sixth", "Seventh",
                  "Eighth", "Close book", "Remove all pages"]);
    caster_face.say("");
    converse (0)
    {
        case "Linear":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 0);
             say("");

             var spells = ["Awaken", "Douse", "Fireworks", "Glimmer", "Help", "Ignite", "Thunder", "Weather"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index - 1]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index - 1])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Awaken":
                   qual = 0;
	           break;
                 case "Douse":
                   qual = 1;
	           break;
                 case "Fireworks":
                   qual = 2;
	           break;
                 case "Glimmer":
                   qual = 3;
	           break;
                 case "Help":
                   qual = 4;
	           break;
                 case "Ignite":
                   qual = 5;
	           break;
                 case "Thunder":
                   qual = 6;
	           break;
                 case "Weather":
                   qual = 7;
	           break;

        case "First":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 1);
             say("");

             var spells = ["Awaken all", "Create food", "Cure", "Detect trap", "Great douse", "Great ignite", "Light", "Locate"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index + 7]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 7])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Awaken all":
                   qual = 8;
	           break;
                 case "Create food":
                   qual = 9;
	           break;
                 case "Cure":
                   qual = 10;
	           break;
                 case "Detect trap":
                   qual = 11;
	           break;
                 case "Great douse":
                   qual = 12;
	           break;
                 case "Great ignite":
                   qual = 13;
	           break;
                 case "Light":
                   qual = 14;
	           break;
                 case "Locate":
                   qual = 15;
	           break;

        case "Second":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 2);
             say("");

             var spells = ["Destroy trap", "Enchant", "Fire blast", "Great light", "Mass cure", "Protection", "Telekinesis", "Wizard eye"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index + 15]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 15])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Destroy trap":
                   qual = 16;
	           break;
                 case "Enchant":
                   qual = 17;
	           break;
                 case "Fire blast":
                   qual = 18;
	           break;
                 case "Great light":
                   qual = 19;
	           break;
                 case "Mass cure":
                   qual = 20;
	           break;
                 case "Protection":
                   qual = 21;
	           break;
                 case "Telekinesis":
                   qual = 22;
	           break;
                 case "Wizard eye":
                   qual = 23;
	           break;

        case "Third":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 3);
             say("");

             var spells = ["Curse", "Heal", "Paralyze", "Peer", "Poison", "Protect all", "Sleep", "Swarm"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index + 23]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 23])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Curse":
                   qual = 24;
	           break;
                 case "Heal":
                   qual = 25;
	           break;
                 case "Paralyze":
                   qual = 26;
	           break;
                 case "Peer":
                   qual = 27;
	           break;
                 case "Poison":
                   qual = 28;
	           break;
                 case "Protect all":
                   qual = 29;
	           break;
                 case "Sleep":
                   qual = 30;
	           break;
                 case "Swarm":
                   qual = 31;
	           break;

        case "Fourth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 4);
             say("");

             var spells = ["Conjure", "Lightning", "Mark", "Mass Curse", "Recall", "Reveal", "Seance", "Unlock magic"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index + 31]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 31])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Conjure":
                   qual = 32;
	           break;
                 case "Lightning":
                   qual = 33;
	           break;
                 case "Mark":
                   qual = 34;
	           break;
                 case "Mass Curse":
                   qual = 35;
	           break;
                 case "Recall":
                   qual = 36;
	           break;
                 case "Reveal":
                   qual = 37;
	           break;
                 case "Seance":
                   qual = 38;
	           break;
                 case "Unlock magic":
                   qual = 39;
	           break;

        case "Fifth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 5);
             say("");

             var spells = ["Charm", "Dance", "Dispel field", "Explosion", "Fire field", "Great heal", "Invisibility", "Mass sleep"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index + 39]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 39])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Charm":
                   qual = 40;
	           break;
                 case "Dance":
                   qual = 41;
	           break;
                 case "Dispel field":
                   qual = 42;
	           break;
                 case "Explosion":
                   qual = 43;
	           break;
                 case "Fire field":
                   qual = 44;
	           break;
                 case "Great heal":
                   qual = 45;
	           break;
                 case "Invisibility":
                   qual = 46;
	           break;
                 case "Mass sleep":
                   qual = 47;
	           break;

        case "Sixth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 6);
             say("");

             var spells = ["Cause fear", "Clone", "Fire ring", "Flame strike", "Magic storm", "Poison field", "Sleep field", "Tremor"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index + 47]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 47])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Cause fear":
                   qual = 48;
	           break;
                 case "Clone":
                   qual = 49;
	           break;
                 case "Fire ring":
                   qual = 50;
	           break;
                 case "Flame strike":
                   qual = 51;
	           break;
                 case "Magic storm":
                   qual = 52;
	           break;
                 case "Poison field":
                   qual = 53;
	           break;
                 case "Sleep field":
                   qual = 54;
	           break;
                 case "Tremor":
                   qual = 55;
	           break;

        case "Seventh":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 7);
             say("");

             var spells = ["Create gold", "Death bolt", "Delayed blast", "Energy field", "Energy mist", "Mass charm", "Mass might", "Restoration"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index + 55]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 55])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Create gold":
                   qual = 56;
	           break;
                 case "Death bolt":
                   qual = 57;
	           break;
                 case "Delayed blast":
                   qual = 58;
	           break;
                 case "Energy field":
                   qual = 59;
	           break;
                 case "Energy mist":
                   qual = 60;
	           break;
                 case "Mass charm":
                   qual = 61;
	           break;
                 case "Mass might":
                   qual = 62;
	           break;
                 case "Restoration":
                   qual = 63;
	           break;

        case "Eighth":
        {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 8);
             say("");

             var spells = ["Armageddon", "Death vortex", "Invisibility all", "Mass death", "Resurrect", "Summon", "Swordstrike", "Time stop"];
             for (choice in spells with index)
             {
                 if ((quality == 5 && get_spellbook()->in_spellbook([index + 63]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 63])))
		            add(choice);
             }
             add("Choose another spell");
        }
                 case "Armageddon":
                   qual = 64;
	           break;
                 case "Death vortex":
                   qual = 65;
	           break;
                 case "Invisibility all":
                   qual = 66;
	           break;
                 case "Mass death":
                   qual = 67;
	           break;
                 case "Resurrect":
                   qual = 68;
	           break;
                 case "Summon":
                   qual = 69;
	           break;
                 case "Swordstrike":
                   qual = 70;
	           break;
                 case "Time stop":
                   qual = 71;
	           break;

        case "Choose another spell":
             UI_clear_answers();
             UI_pop_answers();
             UI_remove_npc_face(SPELLBOOK_FACE);
             caster_face.say("");

        case "Remove all pages": // Dumps all the scroll from the spellbook into a bag at the Avatar's feet..
        {
                caster_face.say("@Should I remove ALL the spells from the spellbook?@");
                if (askYesNo())
                {
                        if (quality == 5)
			        get_spellbook()->dump_spells();
		        else if (quality == 6)
			        get_spellbook2()->dump_spells2();
                }
        }
        case "Close book":
             return;
    }
   }
   if (quality == 255)
   {

                // Create the scroll:
		var spellobj = UI_create_new_object(SPELLSCROLL);
		spellobj->set_item_frame(UI_die_roll(0, 7));
		// Set its quality:
		spellobj->set_item_quality(qual);
		// Place the scroll at the avatar's feet:
		UI_update_last_created(AVATAR->get_object_position());
		// Clear the spell from the spellbook:
                UI_remove_spell(find_SI_spellbook, qual);
    }
    else if (quality == 5)
        get_spellbook()->remove_scroll (qual);
    else if (quality == 6)
        get_spellbook2()->remove_scroll2 (qual);
    else
        caster_face.say("Error, Spellbook shouldn't have this quality.");
}

var Count_Reagents (var speaker, var location) // speaker is the person that speaks the dialog
{                                              // location is NPC or PARTY where reagents are looked for
        var listBP;
        var listBM;
        var listGR;
        var listGN;
        var listMR;
        var listNS;
        var listSS;
        var listSA;
        var listBS;
        var listSC;
        var listWH;

        var quality = get_item_quality();
        var pronoun;
        var REAGENT = 842;
        var BP = 0; // black pearl
        var BM = 1; // blood moss
        var GR = 4; // garlic
        var GN = 5; // ginseng
        var MR = 3; // mandrake root
        var NS = 2; // nightshade
        var SS = 6; // spider's silk
        var SA = 7; // sulfurious ash
        var BS = 8;  // bloodspawn
        var SC = 9;  // serpent scale
        var WH = 10; // worm heart
        var findBP = UI_count_objects(location, REAGENT, QUALITY_ANY, BP);
        var findBM = UI_count_objects(location, REAGENT, QUALITY_ANY, BM);
        var findGR = UI_count_objects(location, REAGENT, QUALITY_ANY, GR);
        var findGN = UI_count_objects(location, REAGENT, QUALITY_ANY, GN);
        var findMR = UI_count_objects(location, REAGENT, QUALITY_ANY, MR);
        var findNS = UI_count_objects(location, REAGENT, QUALITY_ANY, NS);
        var findSS = UI_count_objects(location, REAGENT, QUALITY_ANY, SS);
        var findSA = UI_count_objects(location, REAGENT, QUALITY_ANY, SA);
        var findBS = UI_count_objects(location, REAGENT, QUALITY_ANY, BS);
        var findSC = UI_count_objects(location, REAGENT, QUALITY_ANY, SC);
        var findWH = UI_count_objects(location, REAGENT, QUALITY_ANY, WH);


        if (findBP == 0)
                listBP ="no black pearls, ";
        else if (findBP > 1)
                listBP = findBP + " black pearls, ";
        else
                listBP = "1 black pearl, ";
        if (findBM == 0)
                listBM ="no blood moss,";
        else
                listBM = findBM + " blood moss, ";
        if (findGR == 0)
                listGR ="no garlic, ";
        else
                listGR = findGR + " garlic, ";
        if (findGN == 0)
                listGN ="no ginseng, ";
        else
                listGN = findGN + " ginseng, ";
        if (findMR == 0)
                listMR ="no mandrake root, ";
        else if (findMR > 1)
                listMR = findMR + " mandrake roots, ";
        else
                listMR = "1 mandrake root, ";
        if (findNS == 0)
                listNS ="no nightshade, ";
        else
                listNS = findNS + " nightshade, ";
        if (findSS == 0)
                listSS ="no spider's silk, ";
        else
                listSS = findSS + " spider's silk, ";
        if (findSA == 0)
                listSA ="no sulfurous ash, ";
        else if (findSA > 1)
                listSA = findSA + " sulfurous ashes, ";
        else
                listSA = "1 sulfurous ash, ";
        
        if (findBS == 0)
                listBS ="no bloodspawn, ";
        else
                listBS = findBS + " bloodspawn, ";
        if (findSC == 0)
                listSC ="no serpent scales, ";
        else if (findSC > 1)
                listSC = findSC + " serpent scales, ";
        else
                listSC = "1 serpent scale, ";
        if (findWH == 0)
                listWH ="no worm hearts";
        else if (findWH > 1)
                listWH = findWH + " worm hearts";
        else
                listWH = "1 wormheart";

        if (location == PARTY)
                pronoun = "We";
        else
                pronoun = "I";
        if (quality == 255)
                speaker.say(""+pronoun+" have "+listBP+" "+listBM+" "+listGR+" "+listGN+" "+listMR+" "+listNS+" "+listSS+" "+listSA+" "+listBS+" "+listSC+" and "+listWH+".");
        else
                speaker.say(""+pronoun+" have "+listBP+" "+listBM+" "+listGR+" "+listGN+" "+listMR+" "+listNS+" "+listSS+" and "+listSA+".");
}

/*
//Linear Spells
extern Douse object#()();
extern Fireworks object#()();
extern Glimmer object#()();
extern Help object#()();
extern Ignite object#()();
extern Thunder object#()();
extern Weather object#()();
//First
extern GreatDouse object#()();
extern GreatIgnite object#()();
extern Locate object#()();
//Second
extern Fire_blast object#()();
extern WizardEye object#()();
//Third
extern Peer object#()();
extern Poison object#()();
extern Swarm object#()();
//Fourth
extern Mark object#()();
extern Recall object#()();
extern Seance object#()();
//Fifth
extern Dance object#()();
extern Explosion object#()();
extern Fire_Field object#()();
//Sixth
extern Cause_fear object#()(); 
extern Clone object#()();
extern MagicStorm object#()();
extern Poison_field object#()();
extern Sleep_field object#()();
extern Tremor object#()();
//Seventh
extern Create_gold object#()();
extern Deathbolt object#()();
//extern Energy_Field ();
extern Energy_Mist object#()();
extern MassCharm object#()();
//Eighth
extern Armageddon object#()();
extern Resurrect object#()();
extern Time_stop object#()();
//Other
extern Detect_charges object#()();
extern RechargeMagic object#()();
*/
Spellbook shape#(1224) ()
{
        var caster;
        var caster_face;
        var mana;
        var level;
        var choice;
        var index;
        var spells;
        var function;
        var circle;
        var addingscroll;

        var BP = 0;  // black pearl
        var BM = 1;  // blood moss
        var GR = 4;  // garlic
        var GN = 5;  // ginseng
        var MR = 3;  // mandrake root
        var NS = 2;  // nightshade
        var SS = 6;  // spider's silk
        var SA = 7;  // sulfurious ash
        var BS = 8;  // bloodspawn
        var SC = 9;  // serpent scale
        var WH = 10; // worm heart
        var regs; // indexed as [BP, BM, GR, GN, MR, NS, SS, SA, BS, SR, WH] with 1 replacing the reagent if it is required and 0 if it isn't
        var REAGENT = 842;
        var reagents = [BP, BM, GR, GN, MR, NS, SS, SA, BS, SC, WH];

        var shape = get_item_shape();
        var frame = get_item_frame();
        var quality = get_item_quality();
        var find_SI_spellbook = UI_find_object(PARTY, 761, QUALITY_ANY, FRAME_ANY);

        var bardmana;
        var druidmana;
        var magemana;
        var paladinmana;
        var rangermana;
        var tinkermana;
        var magelevel;
        var bardlevel;
        var druidlevel;
        var paladinlevel;
        var rangerlevel;
        var tinkerlevel;
        const long ExpOne = 51200;

        magelevel = [0, 0, 100, 200, 400, 800, 1600, 3200, 6400]; // same experience for both setting

        // Experience multiplier: spellcasting experience requirements for each spell level in order of linear, 1st, 2nd, 3rd, 4th, 5th, 6th, 7th, 8th
        bardlevel = [50, 100, 200, 400, 800, 1600, 3200, 6400, 12800];
        druidlevel = [25, 50, 134, 267, 534, 1067, 2134, 4267, 8534];
        paladinlevel = [50, 100, 200, 400, 800, 1600, 3200, 6400, 12800];
        rangerlevel = [50, 100, 200, 400, 800, 1600, 3200, 6400, 12800];
        tinkerlevel = [100, 200, 400, 800, 1600, 3200, 6400, 12800, 25600];

        /*// Level multiplier: spellcasting experience requirements for each spell level in order of linear, 1st, 2nd, 3rd, 4th, 5th, 6th, 7th, 8th
        bardlevel = [50, 400, 1000, 1600, 6400, 25600, 102400, 409600, 1638400];
        druidlevel  = [25, 100, 200, 400, 1600, 3200, 6400, 25600, ExpOne];
        paladinlevel = [50, 400, 1000, 1600, 6400, 25600, 102400, 409600, 1638400];
        rangerlevel = [50, 400, 1000, 1600, 6400, 25600, 102400, 409600, 1638400];
        tinkerlevel = [100, 400, 6400, 102400, 1638400, 26214400, 419430400, 419430400, 419430400]; // [100, 400, 6400, 102400, 1638400, 26214400, 419430400, 6710886400, 107374182400];
        */

     if (quality == 255) // SI
     {
        // mana required for each spell level in order of linear, 1st, 2nd, 3rd, 4th, 5th, 6th, 7th, 8th
        bardmana  = [2, 4, 6, 8, 10, 12, 14, 16, 18];
        druidmana  = [2, 3, 4, 6, 7, 8, 10, 11, 12];
        magemana  = [1, 2, 3, 4, 5, 6, 7, 8, 9];
        paladinmana  = [2, 4, 6, 8, 10, 12, 14, 16, 18];
        rangermana  = [2, 4, 6, 8, 10, 12, 14, 16, 18];
        tinkermana  = [4, 8, 12, 16, 20, 24, 28, 32, 36];
     }
     else
     {
        // mana required for each spell level in order of linear, 1st, 2nd, 3rd, 4th, 5th, 6th, 7th, 8th
        bardmana  = [1, 2, 4, 6, 8, 10, 12, 14, 16];
        druidmana  = [1, 2, 3, 4, 6, 7, 8, 10, 11];
        magemana  = [0, 1, 2, 3, 4, 5, 6, 7, 8];
        paladinmana  = [1, 2, 4, 6, 8, 10, 12, 14, 16];
        rangermana  = [1, 2, 4, 6, 8, 10, 12, 14, 16];
        tinkermana  = [2, 4, 8, 12, 16, 20, 24, 28, 32];
     }

  if (quality == 0) // Lord British's Castle
  {
        gflags[AWAKEN] = true;
        gflags[DOUSE] = true;
        gflags[FIREWORKS] = true;
        gflags[GLIMMER] = true;
        gflags[HELP] = true;
        gflags[IGNITE] = true;
        gflags[THUNDER] = true;
        gflags[WEATHER] = true;
        gflags[CURE] = true;
        gflags[LIGHT] = true;
        gflags[FIRE_BLAST] = true;
        gflags[HEAL] = true;
        set_item_quality(1);
        item->Spellbook ();
        return;  // makes sure it reads the right quality after updating
  }
  if (quality == 2) // Destard
  {
        gflags[FIREWORKS2] = true;
        gflags[HELP2] = true;
        gflags[IGNITE2] = true;
        gflags[THUNDER2] = true;
        gflags[CREATE_FOOD2] = true;
        gflags[DETECT_TRAP2] = true;
        gflags[LOCATE2] = true;
        gflags[GREAT_HEAL2] = true;
        gflags[MASS_SLEEP2] = true;
        gflags[CAUSE_FEAR2] = true;
        gflags[FIRE_RING2] = true;
        gflags[SLEEP_FIELD2] = true;
        set_item_quality(3);
        item->Spellbook ();
        return; // makes sure it reads the right quality after updating
  }
  if (UI_is_readied(AVATAR, WEAPON_HAND , shape, frame) && UI_get_cont_items(AVATAR, shape, quality, frame))
  {
        caster = AVATAR;
        caster_face = AVATAR;
        if (gflags[AvatarIsDruid] == true)
        {
           mana = druidmana;
           level = druidlevel;
        }
        else if (gflags[AvatarIsBard] == true)
        {
           mana = bardmana;
           level = bardlevel;
        }
        else if (gflags[AvatarIsRanger] == true)
        {
           mana = rangermana;
           level = rangerlevel;
        }
        else if (gflags[AvatarIsPaladin] == true)
        {
           mana = paladinmana;
           level = paladinlevel;
        }
        else if (gflags[AvatarIsTinker] == true)
        {
           mana = tinkermana;
           level = tinkerlevel;
        }
        else if (gflags[AvatarIsMage] == true)
        {
           mana = magemana;
           level = magelevel;
        }
        else if (gflags[AvatarIsFighter] || gflags[AvatarIsShepherd])
        {
           AVATAR.say("I cannot cast spells");
           return;
        }
        else  //default avatar
        {
           mana = magemana;
           level = magelevel;
        }
  }
  else if ((UI_is_readied(IOLO, WEAPON_HAND , shape, frame) && UI_get_cont_items(IOLO, shape, quality, frame)) // SI Counterpart
        || (UI_is_readied(IOLO_BG, WEAPON_HAND , shape, frame) && UI_get_cont_items(IOLO_BG, shape, quality, frame))) // BG Counterpart
  {
        caster_face = IOLO_FACE;
        mana = bardmana;
        level = bardlevel;
                                //allows the SI Counterpart to use magic
        if (gflags[SET_IOLO_MANA] == false && UI_is_readied(IOLO, WEAPON_HAND , shape, frame)) //
        {
           UI_set_npc_prop(IOLO, MAX_MANA, UI_get_npc_prop(IOLO, INTELLIGENCE));
           UI_set_npc_prop(IOLO, MANA, UI_get_npc_prop(IOLO, INTELLIGENCE));
           gflags[SET_IOLO_MANA] = true;
        }
        if (UI_is_readied(IOLO, WEAPON_HAND , shape, frame))
           caster = IOLO;
        else
           caster = IOLO_BG;
  }
  else if ((UI_is_readied(SHAMINO, WEAPON_HAND , shape, frame) && UI_get_cont_items(SHAMINO, shape, quality, frame)) // SI Counterpart
        || (UI_is_readied(SHAMINO_BG, WEAPON_HAND , shape, frame) && UI_get_cont_items(SHAMINO_BG, shape, quality, frame))) // BG Counterpart
  {
        caster_face = SHAMINO_FACE;
        mana = rangermana;
        level = rangerlevel;
                                //allows the SI Counterpart to use magic
        if (gflags[SET_SHAMINO_MANA] == false && UI_is_readied(SHAMINO, WEAPON_HAND , shape, frame))
        {
           UI_set_npc_prop(SHAMINO, MAX_MANA, UI_get_npc_prop(SHAMINO, INTELLIGENCE));
           UI_set_npc_prop(SHAMINO, MANA, UI_get_npc_prop(SHAMINO, INTELLIGENCE));
           gflags[SET_SHAMINO_MANA] = true;
           caster = SHAMINO;
        }
        if (UI_is_readied(SHAMINO, WEAPON_HAND , shape, frame))
           caster = SHAMINO;
        else
           caster = SHAMINO_BG;
  }
  else if ((UI_is_readied(DUPRE, WEAPON_HAND , shape, frame) && UI_get_cont_items(DUPRE, shape, quality, frame)) // SI Counterpart
        || (UI_is_readied(DUPRE_BG, WEAPON_HAND , shape, frame) && UI_get_cont_items(DUPRE_BG, shape, quality, frame))) // BG Counterpart
  {
        caster_face = DUPRE_FACE;
        mana = paladinmana;
        level = paladinlevel;
                                //allows the SI Counterpart to use magic
        if (gflags[SET_DUPRE_MANA] == false && UI_is_readied(DUPRE, WEAPON_HAND , shape, frame))
        {
           UI_set_npc_prop(DUPRE, MAX_MANA, UI_get_npc_prop(DUPRE, INTELLIGENCE));
           UI_set_npc_prop(DUPRE, MANA, UI_get_npc_prop(DUPRE, INTELLIGENCE));
           gflags[SET_DUPRE_MANA] = true;
        }
        if (UI_is_readied(DUPRE, WEAPON_HAND , shape, frame))
           caster = DUPRE;
        else
           caster = DUPRE_BG;
  }
  else if (UI_is_readied(GWENNO, WEAPON_HAND , shape, frame) && UI_get_cont_items(GWENNO, shape, quality, frame))
  {
        caster = GWENNO;
        caster_face = GWENNO;
        mana = bardmana;
        level = bardlevel;
                                //allows the SI Gwenno to use magic
        if (gflags[SET_GWENNO_MANA] == false)
        {
           UI_set_npc_prop(GWENNO, MAX_MANA, UI_get_npc_prop(GWENNO, INTELLIGENCE));
           UI_set_npc_prop(GWENNO, MANA, UI_get_npc_prop(GWENNO, INTELLIGENCE));
           gflags[SET_GWENNO_MANA] = true;
        }
  }
//BG Companions
  else if (UI_is_readied(JAANA, WEAPON_HAND , shape, frame) && UI_get_cont_items(JAANA, shape, quality, frame))
  {
        caster = JAANA;
        caster_face = JAANA_FACE;
        mana = druidmana;
        level = druidlevel;
  }
  else if (UI_is_readied(JULIA_BG, WEAPON_HAND , shape, frame) && UI_get_cont_items(JULIA_BG, shape, quality, frame))
  {
        caster = JULIA_BG;
        caster_face = JULIA_BG_FACE;
        mana = tinkermana;
        level = tinkerlevel;
  }
  else if (UI_is_readied(LAURIANNA, WEAPON_HAND , shape, frame) && UI_get_cont_items(LAURIANNA, shape, quality, frame))
  {
        caster = LAURIANNA;
        caster_face = LAURIANNA_FACE;
        mana = magemana;
        level = magelevel;
  }
  else if (UI_is_readied(MARIAH, WEAPON_HAND , shape, frame) && UI_get_cont_items(MARIAH, shape, quality, frame))
  {
        caster = MARIAH;
        caster_face = MARIAH_FACE;
        mana = magemana;
        level = magelevel;
  }
  else if (UI_is_readied(TSERAMED, WEAPON_HAND , shape, frame) && UI_get_cont_items(TSERAMED, shape, quality, frame))
  {
        caster = TSERAMED;
        caster_face = TSERAMED_FACE;
        mana = rangermana;
        level = rangerlevel;
  }
  else
  {
        AVATAR.say("If only, that was in the hands of a skilled caster...");
        return;
  }
        var WearingReagentRing = UI_is_readied(caster, 6, 296, 3);
        var WearingReagentRing2 = UI_is_readied(caster, 7, 296, 3);

  //close_gumps();
  if (UI_get_item_flag(caster, ASLEEP) || UI_get_item_flag(caster, CHARMED)
  || UI_get_item_flag(caster, PARALYZED) || UI_get_item_flag(caster, CONFUSED))
  {
        caster.say("Disabled");
        return;
  }
  if (UI_get_weather() == 3)  // in magic storm (no spellcasting zone)
  {
        caster_face.say("These storms are making the ether too unstable.");
        return;
  }

  if (quality == 255) // SI Spellbook for companions (or Avatar) using spells contained in spellbooks shape 761
  {
        add([ "First", "Second", "Third", "Fourth", "Fifth", "Sixth", "Seventh",
              "Eighth", "Ninth", "Count reagents", "Remove a Scroll", "Close book"]);

        caster_face.say("");
        converse (0)
        {
          case "First":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 0);
             say("");
             circle = 0;
             spells = ["Create food", "Cure", "Detect trap", "Great douse", "Great ignite", "Light", "Locate", "Telekinesis"];
             for (choice in spells with index)
             { 
                 if (UI_has_spell(find_SI_spellbook , index - 1))
		            add(choice);
             }

             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Create food":
                   function = 0x640;
                   regs = [0, 0, 1, 1, 1];
	           break;
                 case "Cure":
                   function = 0x641;
                   regs = [0, 0, 1, 1];
	           break;
                 case "Detect trap":
                   function = 0x642;
                   regs = [0, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Great douse":
                   function = 0x643;
                   regs = [0, 0, 1, 0, 0, 0, 1];
	           break;
                 case "Great ignite":
                   function = 0x644;
                   regs = [0, 0, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Light":
                   function = 0x645;
                   regs = [0, 0, 0, 0, 0, 0, 0, 1];
	           break;
                 case "Locate":
                   function = 0x646;
                   regs = [1, 1, 0, 0, 1];
	           break;
                 case "Telekinesis":
                   function = 0x647;
                   regs = [1, 1, 0, 0, 1];
	           break;

          case "Second":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 1);
             say("");
             circle = 1;
             var spells = ["Awaken", "Destroy trap", "False Coin", "Cold blast", "Great light", "Heal", "Mass cure", "Protection"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 7))
		            add(choice);
             }
             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Awaken":
                   function = 0x648;
	           regs = [0, 0, 1, 1];
	           break;
                 case "Destroy trap":
                   function = 0x649;
	           regs = [0, 1, 0, 0, 0, 0, 0, 1];
	           break;
                 case "False Coin":
                   function = 0x64A;
	           regs = [0, 0, 0, 0, 0, 1, 0, 1];
	           break;
                 case "Cold blast":
                   function = 0x64B;
	           regs = [1, 1, 0, 0, 1];
	           break;
                 case "Great light":
                   function = 0x64C;
	           regs = [0, 0, 0, 0, 1, 0, 0, 1];
	           break;
                 case "Heal":
                   function = 0x64D;
	           regs = [0, 0, 1, 1, 0, 0, 1];
	           break;
                 case "Mass cure":
                   function = 0x64E;
                   regs = [0, 0, 1, 1, 1];
	           break;
                 case "Protection":
                   function = 0x64F;
                   regs = [0, 0, 1, 1, 0, 0, 0, 1];
	           break;

          case "Third":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 2);
             say("");
             circle = 2;
             var spells = ["Chill", "Curse", "Enchant missiles", "Columna's intuition", "Protect all", "Paralyze", "Sleep", "Translation"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 15))
		            add(choice);
             }
             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Chill":
                   function = 0x650;
	           regs = [0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1];
                   break;
                 case "Curse":
                   function = 0x651;
	           regs = [0, 0, 1, 0, 0, 1, 0, 1];
	           break;
                 case "Enchant missiles":
                   function = 0x652;
	           regs = [1, 0, 0, 0, 1];
	           break;
                 case "Columna's intuition":
                   function = 0x653;
	           regs = [1, 0, 1];
	           break;
                 case "Protect all":
                   function = 0x654;
	           regs = [0, 0, 1, 1, 1, 0, 0, 1];
	           break;
                 case "Paralyze":
                   function = 0x655;
	           regs = [0, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Sleep":
                   function = 0x656;
	           regs = [1, 0, 0, 0, 1, 0, 1, 1];
	           break;
                 case "Translation":
                   function = 0x657;
	           regs = [1, 0, 0, 0, 1, 0, 1, 1];
	           break;

          case "Fourth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 3);
             say("");
             circle = 3;
             var spells = ["Blink", "Deter", "Flash", "Create soul prism", "Mass curse", "Reveal", "Transcribe", "Unlock Magic"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 23))
		            add(choice);
             }
             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Blink":
                   function = 0x658;
	           regs = [0, 1, 0, 0, 1];
	           break;
                 case "Deter":
                   function = 0x659;
	           regs = [0, 0, 1, 0, 0, 0, 1];
	           break;
                 case "Flash":
                   function = 0x65A;
	           regs = [0, 0, 0, 0, 1, 0, 0, 1];
	           break;
                 case "Create soul prism":
                   function = 0x65B;
	           regs = [0, 1, 1, 0, 1, 0, 1, 1, 0, 1];
	           break;
                 case "Mass curse":
                   function = 0x65C;
	           regs = [0, 0, 1, 0, 1, 1, 0, 1];
	           break;
                 case "Reveal":
                   function = 0x65D;
	           regs = [0, 1, 0, 0, 0, 0, 0, 1];
	           break;
                 case "Transcribe":
                   function = 0x65E;
	           regs = [1, 0, 0, 0, 0, 0, 1];
	           break;
                 case "Unlock Magic":
                   function = 0x65F;
	           regs = [0, 1, 0, 0, 0, 0, 0, 1];
	           break;

          case "Fifth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 4);
             say("");
             circle = 4;
             var spells = ["Conjure", "Dispel field", "Explosion", "Great heal", "Invisibility", "Mass sleep", "Summon shade", "Erstam's surprise"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 31))
		            add(choice);
             }
             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Conjure":
                   function = 0x660;
	           regs = [0, 0, 0, 0, 1, 0, 1];
	           break;
                 case "Dispel field":
                   function = 0x661;
	           regs = [1, 0, 1, 0, 0, 0, 1, 1];
	           break;
                 case "Explosion":
                   function = 0x662;
	           regs = [1, 1, 0, 0, 1, 0, 0, 1];
	           break;
                 case "Great heal":
                   function = 0x663;
	           regs = [0, 0, 1, 1, 1, 0, 1];
	           break;
                 case "Invisibility":
                   function = 0x664;
	           regs = [0, 1, 0, 0, 0, 1];
	           break;
                 case "Mass sleep":
                   function = 0x665;
	           regs = [0, 0, 0, 1, 0, 1, 1];
	           break;
                 case "Summon shade":
                   function = 0x666;
	           regs = [0, 1, 0, 0, 1, 1, 1, 1];
	           break;
                 case "Erstam's surprise":
                   function = 0x667;
	           regs = [1, 0, 1, 0, 1, 0, 0, 1];
	           break;

          case "Sixth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 5);
             say("");
             circle = 5;
             var spells = ["Betray", "Dispel illusion", "Cause fear", "Fire field", "Fire ring", "Cold strike", "Create ammo", "Create Automaton"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 39))
		            add(choice);
             }
             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Betray":
                   function = 0x668;
	           regs = [1, 0, 1, 0, 1, 0, 0, 1];
	           break;
                 case "Dispel illusion":
                   function = 0x669;
	           regs = [0, 0, 1, 0, 1, 1];
	           break;
                 case "Cause fear":
                   function = 0x66A;
	           regs = [0, 0, 1, 0, 1, 1];
	           break;
                 case "Fire field":
                   function = 0x66B;
	           regs = [1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1];
	           break;
                 case "Fire ring":
                   function = 0x66C;
	           regs = [1, 0, 0, 0, 1, 0, 1, 1, 0, 0, 1];
	           break;
                 case "Cold strike":
                   function = 0x66D;
	           regs = [1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1];
	           break;
                 case "Create ammo":
                   function = 0x66E;
	           regs = [0, 1, 0, 1, 0, 0, 0, 1];
	           break;
                 case "Create Automaton":
                   function = 0x66F;
	           regs = [0, 0, 0, 0, 1, 0, 1, 1, 0, 1];
	           break;

          case "Seventh":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 6);
             say("");
             circle = 6;
             var spells = ["Energy field", "Energy mist", "Mass awaken", "Mass might", "Poison mist", "Restoration", "Vibrate", "Lightning"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 47))
		            add(choice);
             }
             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Energy field":
                   function = 0x670;
	           regs = [1, 0, 0, 0, 1, 0, 1, 1];
	           break;
                 case "Energy mist":
                   function = 0x671;
	           regs = [0, 1, 0, 0, 1, 1, 0, 1];
	           break;
                 case "Mass awaken":
                   function = 0x672;
	           regs = [0, 0, 1, 1];
	           break;
                 case "Mass might":
                   function = 0x673;
	           regs = [1, 0, 0, 1, 1];
	           break;
                 case "Poison mist":
                   function = 0x674;
	           regs = [0, 1, 0, 0, 0, 1, 0, 1];
	           break;
                 case "Restoration":
                   function = 0x675;
	           regs = [0, 0, 1, 1, 1, 0, 1];
	           break;
                 case "Vibrate":
                   function = 0x676;
	           regs = [1, 1, 0, 0, 1, 0, 1];
	           break;
                 case "Lightning":
                   function = 0x677;
	           regs = [1, 0, 0, 0, 1, 0, 0, 1];
	           break;

          case "Eighth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 7);
             say("");
             circle = 7;
             var spells = ["Create ice", "Mind blast", "Delayed blast", "Fetch", "Invoke snow serpent", "Serpent bond", "Fire snake", "Swordstrike"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 55))
		            add(choice);
             }
             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Create ice":
                   function = 0x678;
	           regs = [0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1];
	           break;
                 case "Mind blast":
                   function = 0x679;
	           regs = [1, 0, 0, 0, 0, 1, 0, 1, 1];
	           break;
                 case "Delayed blast":
                   function = 0x67A;
	           regs = [1, 1, 0, 0, 1];
	           break;
                 case "Fetch":
                   function = 0x67B;
	           regs = [1, 1, 0, 0, 1];
	           break;
                 case "Invoke snow serpent":
                   function = 0x67C;
	           regs = [0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1];
	           break;
                 case "Serpent bond":
                   function = 0x67D;
	           regs = [0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1];
	           break;
                 case "Fire snake":
                   function = 0x67E;
	           regs = [0, 0, 1, 0, 1, 0, 0, 1];
	           break;
	         case "Swordstrike":
                   function = 0x67F;
	           regs = [1, 0, 0, 0, 1, 1, 0, 0, 1];
	           break;

          case "Ninth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SI_SPELLBOOK_FACE, 8);
             say("");
             circle = 8;
             var spells = ["Death vortex", "Mass death", "Invisible all", "Spiral missile", "Stop storm", "Summon", "Time stop", "Imbalance"];
             for (choice in spells with index)
             {
                 if (UI_has_spell(find_SI_spellbook , index + 63))
		            add(choice);
             }
             if (gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Death vortex":
                   function = 0x680;
	           regs = [0, 1, 0, 0, 1, 1, 0, 1];
	           break;
                 case "Mass death":
                   function = 0x681;
	           regs = [0, 1, 1, 1, 1, 1, 0, 0, 1];
	           break;
                 case "Invisibility all":
                   function = 0x682;
	           regs = [1, 1, 0, 0, 1, 1];
	           break;
                 case "Spiral missile":
                   function = 0x683;
	           regs = [1, 1, 0, 0, 0, 1, 0, 1, 1];
	           break;
                 case "Stop storm":
                   function = 0x684;
	           regs = [1, 0, 1, 0, 1, 0, 1];
                   break;
                 case "Summon":
                   function = 0x685;
	           regs = [0, 1, 1, 0, 1, 0, 1];
	           break;
                 case "Time stop":
                   function = 0x686;
	           regs = [0, 1, 1, 0, 1];
	           break;
                 case "Imbalance":
                   function = 0x687;
	           regs = [0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1];
	           break;
          
          case "Choose another spell":
             UI_clear_answers();
             UI_pop_answers();
             UI_remove_npc_face(SI_SPELLBOOK_FACE);
             caster_face.say("");

          case "Remove a Scroll":
          {
                script item
                {
                        call Remove_a_scroll, DOUBLECLICK;
                }
                return;
          }
          case "Count reagents":
          {
                if (UI_get_array_size([UI_get_party_list()]) == 1)
                        Count_Reagents (caster_face, caster);
                else
                {
                        caster_face.say("@Should I count my reagents or the party's?@");
                        if (ChooseFromAnswers(["Mine", "Party's"]) == "Mine")
                                Count_Reagents (caster_face, caster);
                        else
                                Count_Reagents (caster_face, PARTY);
                }
          }
          case "Close book":
             abort;
        }
  }
  else
  {
        if (quality == 5 || quality == 6)
             add(["Linear", "First", "Second", "Third", "Fourth", "Fifth", "Sixth", "Seventh",
                  "Eighth", "Class skills", "Add Scroll", "Remove a Scroll", "Count reagents", "Close book"]);
        else
             add(["Linear", "First", "Second", "Third", "Fourth", "Fifth", "Sixth",
                  "Seventh", "Eighth", "Class skills", "Count reagents", "Close book"]);

        caster_face.say("");
        converse (0)
        {
          case "Linear":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 0);
             say("");
             circle = 0;
	     regs = [];
             var spells = ["Awaken", "Douse", "Fireworks", "Glimmer", "Help", "Ignite", "Thunder", "Weather"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[AWAKEN + index - 1])
                 || (quality == 3 && gflags[AWAKEN2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index - 1]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index - 1]))
                 || (quality == 255 && UI_has_spell(find_SI_spellbook, 1)))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Awaken":
                   function = 0x648;
	           break;
                 case "Douse":
                   function = &Douse;
	           break;
                 case "Fireworks":
                   function = &Fireworks;
	           break;
                 case "Glimmer":
                   function = &Glimmer;
	           break;
                 case "Help":
                   function = &Help;
	           break;
                 case "Ignite":
                   function = &Ignite;
	           break;
                 case "Thunder":
                   function = &Thunder;
	           break;
                 case "Weather":
                   function = &Weather;
	           break;

          case "First":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 1);
             say("");
             circle = 1;
             var spells = ["Awaken all", "Create food", "Cure", "Detect trap", "Great douse", "Great ignite", "Light", "Locate"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[AWAKEN_ALL + index - 1])
                 || (quality == 3 && gflags[AWAKEN_ALL2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index + 7]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 7])))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Awaken all":
                   function = 0x672;
	           regs = [0, 0, 1, 1];
	           break;
                 case "Create food":
                   function = 0x640;
	           regs = [0, 0, 1, 1, 1];
	           break;
                 case "Cure":
                   function = 0x641;
	           regs = [0, 0, 1, 1];
	           break;
                 case "Detect trap":
                   function = 0x642;
	           regs = [0, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Great douse":
                   function = &GreatDouse;
	           regs = [0, 0, 1, 0, 0, 0, 1];
	           break;
                 case "Great ignite":
                   function = &GreatIgnite;
	           regs = [0, 0, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Light":
                   function = 0x645;
                   regs = [0, 0, 0, 0, 0, 0, 0, 1];
	           break;
                 case "Locate":
                   function = &Locate;
                   regs = [0, 0, 0, 0, 0, 1];
	           break;

          case "Second":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 2);
             say("");
             circle = 2;
             var spells = ["Destroy trap", "Enchant", "Fire blast", "Great light", "Mass cure", "Protection", "Telekinesis", "Wizard eye"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[DESTROY_TRAP + index - 1])
                 || (quality == 3 && gflags[DESTROY_TRAP2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index + 15]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 15])))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Destroy trap":
                   function = 0x649;
	           regs = [0, 1, 0, 0, 0, 0, 0, 1];
                   break;
                 case "Enchant":
                   function = 0x652;
	           regs = [1, 0, 0, 0, 1];
	           break;
                 case "Fire blast":
                   function = &Fire_blast;
	           regs = [1, 0, 0, 0, 0, 0, 0, 1];
	           break;
                 case "Great light":
                   function = 0x64C;
	           regs = [0, 0, 0, 0, 1, 0, 0, 1];
	           break;
                 case "Mass cure":
                   function = 0x64E;
	           regs = [0, 0, 1, 1, 1];
	           break;
                 case "Protection":
                   function = 0x64F;
	           regs = [0, 0, 1, 1, 0, 0, 0, 1];
	           break;
                 case "Telekinesis":
                   function = 0x647;
	           regs = [1, 1, 0, 0, 1];
	           break;
                 case "Wizard eye":
                   function = &WizardEye;
	           regs = [1, 1, 0, 0, 1, 1, 1, 1];
	           break;

          case "Third":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 3);
             say("");
             circle = 3;
             var spells = ["Curse", "Heal", "Paralyze", "Peer", "Poison", "Protect all", "Sleep", "Swarm"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[CURSE + index - 1])
                 || (quality == 3 && gflags[CURSE2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index + 23]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 23])))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Curse":
                   function = 0x651;
	           regs = [0, 0, 1, 0, 0, 1, 0, 1];
	           break;
                 case "Heal":
                   function = 0x64D;
	           regs = [0, 0, 1, 1, 0, 0, 1];
	           break;
                 case "Paralyze":
                   function = 0x655;
	           regs = [0, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Peer":
                   function = &Peer;
	           regs = [0, 0, 0, 0, 1, 1];
	           break;
                 case "Poison":
                   function = &Poison;
	           regs = [1, 1, 0, 0, 0, 1];
	           break;
                 case "Protect all":
                   function = 0x654;
	           regs = [0, 0, 1, 1, 1, 0, 0, 1];
	           break;
                 case "Sleep":
                   function = 0x656;
	           regs = [1, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Swarm":
                   function = &Swarm;
	           regs = [0, 1, 0, 0, 1, 1];
	           break;

          case "Fourth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 4);
             say("");
             circle = 4;
             var spells = ["Conjure", "Lightning", "Mark", "Mass Curse", "Recall", "Reveal", "Seance", "Unlock magic"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[CONJURE + index - 1])
                 || (quality == 3 && gflags[CONJURE2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index + 31]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 31])))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Conjure":
                   function = 0x660;
	           regs = [0, 0, 0, 0, 1, 0, 1];
	           break;
                 case "Lightning":
                   function = 0x677;
	           regs = [1, 0, 0, 0, 1, 0, 0, 1];
	           break;
                 case "Mark":
                   function = &Mark;
	           regs = [1, 1, 0, 0, 1];
	           break;
                 case "Mass Curse":
                   function = 0x65C;
	           regs = [0, 0, 1, 0, 1, 1, 0, 1];
	           break;
                 case "Recall":
                   function = &Recall;
	           regs = [1, 1, 0, 0, 1];
	           break;
                 case "Reveal":
                   function = 0x65D;
	           regs = [0, 1, 0, 0, 0, 0, 0, 1];
	           break;
                 case "Seance":
                   function = &Seance;
	           regs = [0, 1, 0, 0, 1, 1, 1, 1];
	           break;
                 case "Unlock magic":
                   function = 0x65F;
	           regs = [0, 1, 0, 0, 0, 0, 0, 1];
	           break;

          case "Fifth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 5);
             say("");
             circle = 5;
             var spells = ["Charm", "Dance", "Dispel field", "Explosion", "Fire field", "Great heal", "Invisibility", "Mass sleep"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[CHARM + index - 1])
                 || (quality == 3 && gflags[CHARM2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index + 39]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 39])))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Charm":
                   function = 0x668;
	           regs = [1, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Dance":
                   function = &Dance;
	           regs = [0, 1, 1, 0, 1];
	           break;
                 case "Dispel field":
                   function = 0x661;
	           regs = [1, 0, 1, 0, 0, 0, 1, 1];
	           break;
                 case "Explosion":
                   function = &Explosion;
	           regs = [1, 1, 0, 0, 1, 0, 0, 1];
	           break;
                 case "Fire field":
                   function = &Fire_Field;
	           regs = [1, 0, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Great heal":
                   function = 0x663;
	           regs = [0, 0, 1, 1, 1, 0, 1];
	           break;
                 case "Invisibility":
                   function = 0x664;
	           regs = [0, 1, 0, 0, 0, 1];
	           break;
                 case "Mass sleep":
                   function = 0x665;
	           regs = [0, 0, 0, 1, 0, 1, 1];
	           break;

          case "Sixth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 6);
             say("");
             circle = 6;
             var spells = ["Cause fear", "Clone", "Fire ring", "Flame strike", "Magic storm", "Poison field", "Sleep field", "Tremor"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[CAUSE_FEAR + index - 1])
                 || (quality == 3 && gflags[CAUSE_FEAR2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index + 47]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 47])))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Cause fear":
                   function = 0x66A;
	           regs = [0, 0, 1, 0, 1, 1];
	           break;
                 case "Clone":
                   function = &Clone;
	           regs = [0, 1, 0, 1, 1, 1, 1, 1];
	           break;
                 case "Fire ring":
                   function = 0x66C;
	           regs = [1, 0, 0, 0, 1, 0, 1, 1];
	           break;
                 case "Flame strike":
                   function = 0x66D;
	           regs = [1, 1, 0, 0, 0, 0, 0, 1];
	           break;
                 case "Magic storm":
                   function = &MagicStorm;
	           regs = [0, 1, 0, 0, 1, 1, 0, 1];
	           break;
                 case "Poison field":
                   function = &Poison_field;
	           regs = [1, 0, 0, 0, 0, 1, 1];
	           break;
                 case "Sleep field":
                   function = &Sleep_field;
	           regs = [1, 0, 0, 1, 0, 0, 1];
	           break;
                 case "Tremor":
                   function = &Tremor;
	           regs = [0, 1, 0, 0, 1, 0, 0, 1];
	           break;

          case "Seventh":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 7);
             say("");
             circle = 7;
             var spells = ["Create gold", "Death bolt", "Delayed blast", "Energy field", "Energy mist", "Mass charm", "Mass might", "Restoration"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[CREATE_GOLD + index - 1])
                 || (quality == 3 && gflags[CREATE_GOLD2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index + 55]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 55])))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Create gold":
                   function = &Create_gold;
	           regs = [0, 0, 0, 0, 1, 0, 1];
	           break;
                 case "Death bolt":
                   function = &Deathbolt;
	           regs = [1, 0, 0, 0, 0, 1, 0, 1];
	           break;
                 case "Delayed blast":
                   function = 0x67A;
	           regs = [1, 1, 0, 0, 1, 0, 1, 1];
	           break;
                 case "Energy field":
                   function = 0x670;
	           regs = [1, 0, 0, 0, 1, 0, 1, 1];
	           break;
                 case "Energy mist":
                   function = &Energy_Mist;
	           regs = [0, 1, 0, 0, 1, 1, 0, 1];
	           break;
                 case "Mass charm":
                   function = &MassCharm;
	           regs = [1, 0, 0, 0, 1, 1, 1];
	           break;
                 case "Mass might":
                   function = 0x673;
	           regs = [1, 0, 0, 1, 1];
	           break;
                 case "Restoration":
                   function = 0x675;
	           regs = [0, 0, 1, 1, 1, 0, 1];
	           break;

          case "Eighth":
          {
             caster_face.hide();
             UI_push_answers();
             UI_show_npc_face(SPELLBOOK_FACE, 8);
             say("");
             circle = 8;
             var spells = ["Armageddon", "Death vortex", "Invisibility all", "Mass death", "Resurrect", "Summon", "Swordstrike", "Time stop"];
             for (choice in spells with index)
             {
                 if ((quality == 1 && gflags[ARMAGEDDON + index - 1])
                 || (quality == 3 && gflags[ARMAGEDDON2 + index - 1])
                 || (quality == 5 && get_spellbook()->in_spellbook([index + 63]))
                 || (quality == 6 && get_spellbook2()->in_spellbook2([index + 63])))
		            add(choice);
             }
             if (quality == 4 || gflags[WIZARD_MODE])
		 add(spells);
             add("Choose another spell");
          }
                 case "Armageddon":
                   function = &Armageddon;
	           regs = [1, 1, 1, 1, 1, 1, 1, 1];
	           break;
                 case "Death vortex":
                   function = 0x680;
	           regs = [0, 1, 0, 0, 1, 1, 0, 1];
	           break;
                 case "Invisibility all":
                   function = 0x682;
	           regs = [1, 1, 0, 0, 1, 1];
	           break;
                 case "Mass death":
                   function = 0x681;
	           regs = [0, 1, 1, 1, 1, 1];
	           break;
                 case "Resurrect":
                   function = &Resurrect;
	           regs = [0, 0, 1, 1, 0, 0, 1, 1];
                   break;
                 case "Summon":
                   function = 0x685;
	           regs = [0, 1, 1, 0, 1];
	           break;
                 case "Swordstrike":
                   function = 0x67F;
	           regs = [1, 0, 0, 0, 1, 1];
	           break;
                 case "Time stop":
                   function = &Time_stop;
	           regs = [0, 1, 1, 0, 1];
	           break;

          case "Class skills":
          {
             UI_push_answers();
             add("Choose another spell");
             add(["Detect Charges", "Recharge Magic"]);
          }
                 case "Detect Charges":
                   function = &Detect_charges;
	           circle = 0;
	           regs = [];
	           break;
                 case "Recharge Magic":
                   function = &RechargeMagic;
	           circle = 0;
	           regs = [];
	           break;

          case "Choose another spell":
             UI_clear_answers();
             UI_pop_answers();
             UI_remove_npc_face(SPELLBOOK_FACE);
             caster_face.say("");

          case "Add Scroll":
                addingscroll = true;
                break;

          case "Remove a Scroll":
          {
                script item
                {
                        call Remove_a_scroll, DOUBLECLICK;
                }
                return;
          }
          case "Count reagents":
          {
                if (UI_get_array_size([UI_get_party_list()]) == 1)
                        Count_Reagents (caster_face, caster);
                else
                {
                        caster_face.say("@Should I count my reagents or the party's?@");
                        if (ChooseFromAnswers(["Mine", "Party's"]) == "Mine")
                                Count_Reagents (caster_face, caster);
                        else
                                Count_Reagents (caster_face, PARTY);
                }
          }
          case "Close book":
             abort;
        }
    }
    if (addingscroll)
    {
        script item
        {
          call AddScrollFromBook, DOUBLECLICK;
        }
    }
    else if (gflags[WIZARD_MODE])
    {
        script caster
        {
          call function, DOUBLECLICK;
        }
    }
    else if (WearingReagentRing && UI_get_npc_prop(caster, MANA) >= mana[circle+1]
    && UI_get_npc_prop(caster, EXPERIENCE) >= level[circle+1])
    {
        UI_set_npc_prop(caster, MANA, - mana[circle+1]);
        script caster
        {
          call function, DOUBLECLICK;
        }
    }
    else if (WearingReagentRing2 && UI_get_npc_prop(caster, MANA) >= mana[circle+1]
    && UI_get_npc_prop(caster, EXPERIENCE) >= level[circle+1])
    {
        UI_set_npc_prop(caster, MANA, - mana[circle+1]);
        script caster
        {
          call function, DOUBLECLICK;
        }
    }
    else if (!(UI_get_npc_prop(caster, EXPERIENCE) >= level[circle+1]))
    {
          if (UI_get_random(100) >= 50)
               caster_face.say("More skill in molding the ether is required before such an attempt can be made");
          else if (UI_get_random(100) >= 2)
               caster_face.say("Perhaps in time this level of skill will be achived");
          else
               caster_face.say("Psst, global flag 1600 activates the wizardry mode for this spellbook");
    }
    else if (!(UI_get_npc_prop(caster, MANA) >= mana[circle+1]))
    {
          if (UI_get_random(100) >= 50)
               caster_face.say("More spiritual energy must be aquired before accessing into the ether");
          else if (UI_get_random(100) >= 2)
               caster_face.say("I need to rest before I can attempt that");
          else
               caster_face.say("Psst, global flag 1600 activates the wizardry mode for this spellbook");
    }
    else
    {
        for (removed in reagents with index) //must be two of these or else it will remove ingredients if it has at least one of them
        {
              if (regs[index] == 1)
              {
                   if (!UI_count_objects(caster, REAGENT, QUALITY_ANY, removed))
                   {
                         if (UI_get_random(100) >= 50)
                               caster_face.say("I need to aquire the proper reagents first.");
                         else if (UI_get_random(100) >= 2)
                               caster_face.say("Now then, what are the reagents I require?");
                         else
                         {
                               caster_face.say("Damn! I knew we should have gotten more reagents.");
                               caster_face.say("But no, \"you\" thought we didn't need any.");
                         }
                         return;
                   }
              }
        }
        for (removed in reagents with index) //must be two of these or else it will remove ingredients if it has at least one of them
        {
              if (regs[index] == 1)
              {
                   UI_remove_cont_items(caster, 1, REAGENT, QUALITY_ANY, removed);
              }
        }
        UI_set_npc_prop(caster, MANA, - mana[circle+1]);
        script caster
        {
              call function, DOUBLECLICK;
        }
    }
}

AddScroll object# ()()
{
                //Prompt player for target:
                var target = UI_click_on_item();
	        //Target is the spellbook:
	        if (target->get_item_shape() == SPELLBOOK && target->get_item_quality() == 5)
                       get_spellbook()->add_to_spellbook(target, item);
	        else if (target->get_item_shape() == SPELLBOOK && target->get_item_quality() == 6)
                       get_spellbook2()->add_to_spellbook2(target, item);
                return;
}

SpellScroll shape#(1306) ()
{
        //If we didn't came here via double-click, leave:
	if (!(event == DOUBLECLICK)) return;
        var quality = get_item_quality();
        var frame = 0;
        var allow_cast = false; // make true if you want qualities lower than 100 to be able to cast spells too.
        var adding_scroll;

        var spells = ["Awaken", "Douse", "Fireworks", "Glimmer", "Help", "Ignite", "Thunder", "Weather",                         // Linear
        "Awaken all", "Create food", "Cure", "Detect trap", "Great douse", "Great ignite", "Light", "Locate",                    // 1st
        "Destroy trap", "Enchant", "Fire blast", "Great light", "Mass cure", "Protection", "Telekinesis", "Wizard eye",          // 2nd
        "Curse", "Heal", "Paralyze", "Peer", "Poison", "Protect all", "Sleep", "Swarm",                                          // 3rd
        "Conjure", "Lightning", "Mark", "Mass Curse", "Recall", "Reveal", "Seance", "Unlock magic",                              // 4th
        "Charm", "Dance", "Dispel field", "Explosion", "Fire field", "Great heal", "Invisibility", "Mass sleep",                 // 5th
        "Cause fear", "Clone", "Fire ring", "Flame strike", "Magic storm", "Poison field", "Sleep field", "Tremor",              // 6th
        "Create gold", "Death bolt", "Delayed blast", "Energy field", "Energy mist", "Mass charm", "Mass might", "Restoration",  // 7th
        "Armageddon", "Death vortex", "Invisibility all", "Mass death", "Resurrect", "Summon", "Swordstrike", "Time stop",       // 8th
        "Detect Charges", "Recharge Magic"];                                                                                     // Other

        for (choice in spells with index)
        {
                 if (quality == index -1) // qualities 0 through 84 only Add to spellbook unless over HighestSpellbookQuality ie over Time stop
                 {
                       UI_show_npc_face(SPELLSCROLL_FACE, quality);

                       if (quality <= HighestSpellbookQuality)
                            add([choice, "Add to a spellbook"]);
                       else
                            add([choice, "Cast from the scroll"]);
                 }
                 if (quality == index + 84) // qualities 85 through 170 only Cast from scroll
                 {
                       add([choice, "Cast from the scroll"]);
                       UI_show_npc_face(SPELLSCROLL_FACE, quality -85);
                 }
                 if (quality == index + 169) // qualities 170 through 255 Add to spellbook unless over HighestSpellbookQuality + 170 ie Time stop
                 {                           // and Cast from scroll
                       UI_show_npc_face(SPELLSCROLL_FACE, quality -170);
                       if (quality <= HighestSpellbookQuality + 170)
                            add([choice, "Add to a spellbook", "Cast from the scroll"]);
                       else
                            add([choice, "Cast from the scroll"]);
                 }

        }
        add("close scroll");
        converse (0)
        {
// Linear
            case "Awaken" (remove):
            {
                say("This spell pulls one individual from the trance of sleep, whether sleeping from fatigue or enchantment.");
            }
            case "Douse" (remove):
            {
                say("This spell extinguishes any small, non-magical fire.");
            }
            case "Fireworks" (remove):
            {
                say("This spell releases an impressive display of multicolored moving lights.");
            }
            case "Glimmer" (remove):
            {
                say("This spell creates a small light source that last for a short period of time.");
            }
            case "Help" (remove):
            {
                say("This spell teleports the mage and his party to Lord British's castle.");
            }
            case "Ignite" (remove):
            {
                say("This spell generates a tiny missile of sparks that can ignite flammable material.");
            }
            case "Thunder" (remove):
            {
                say("This spell causes a single thunderclap to be heard, as if a terrible storm is imminent.");
            }
            case "Weather" (remove):
            {
                say("This spell can create a storm or cause an existing storm to stop.");
            }
// 1st
            case "Awaken all" (remove):
            {
                say("This spell awakens all unconscious members of the mage's party. The reagents required are garlic and ginseng.");
            }
            case "Create food" (remove):
            {
                say("This spell calls forth enough food to address the hunger of the caster and any dinner guests, as if a single meal had been served. The reagents required are garlic, ginseng, and mandrake root.");
            }
            case "Cure" (remove):
            {
                say("This spell neutralizes the effects of all poisons on its subject, including those of a paralytic nature. The reagents required are garlic and ginseng.");
            }
            case "Detect trap" (remove):
            {
                say("This spell reveals all traps near the caster. The reagents required are nightshade and spider's silk.");
            }
            case "Great douse" (remove):
            {
                say("This spell extinguishes all small non-magical flames within view of the caster. The reagents required are garlic and spider's silk");
            }
            case "Great ignite" (remove):
            {
                say("This spell causes all easily combustible items within the area to burst into flames. The reagents required are spider's silk and sulfurous ash.");
            }
            case "Light" (remove):
            {
                say("This spell brings into being a mobile source of light that lasts a significant amount of time. The reagent required is sulfurous ash.");
            }
            case "Locate" (remove):
            {
                say("This spell identifies the sextant position of the mage, even while underground. The reagent required is nightshade.");
            }
// 2nd
            case "Destroy trap" (remove):
            {
                say("This spell destroys any one specific trap upon which it is cast. The reagents required are blood moss and sulfurous ash");
            }
            case "Enchant" (remove):
            {
                say("Affecting an entire bundle if present, this spell enchants arrows and bolts so as to enhance their effectiveness. The reagents required are black pearl and mandrake root.");
            }
            case "Fire blast" (remove):
            {
                say("This spell causes great jets of flame to burst forth from the mage and strike his target. The reagents required are sulfurous ash.");
            }
            case "Great light" (remove):
            {
                say("This spell is a more potent version of light and has a substantially longer duration. The reagents required are mandrake root and sulfurous ash.");
            }
            case "Mass cure" (remove):
            {
                say("This spell cures the mages and all those with him. The reagents required are garlic, ginseng, and mandrake root.");
            }
            case "Protection" (remove):
            {
                say("Not only does this spell reduce the subject's vulnerability to attack, it also temporarily eliminates the possibility of harm from traps. The reagents required are garlic, ginseng, and sulfurous ash.");
            }
            case "Telekinesis" (remove):
            {
                say("This spell allows the mage to manipulate objects without touching them. The reagents are black pearl, blood moss, and mandrake root.");
            }
            case "Wizard eye" (remove):
            {
                say("This spell enables the mage to greatly extend his sight out over great distances, passing through any barriers that exist between himself and anything he wishes to look at. The reagents required are black pearl, blood moss, mandrake root, nightshade, spider's silk, and sulfurous ash.");
            }
// 3rd
            case "Curse" (remove):
            {
                say("This spell this is a minor curse that temporarily makes an enemy easier to hit in combat, while making  it harder for him to strike. The reagents required are garlic, nightshade, and sulfurous ash.");
            }
            case "Heal" (remove):
            {
                say("This powerful enchantment speeds up the healing process of most wounds, as if the afflicted were to rest for a great many days. The reagents required are garlic, ginseng, and spider's silk.");
            }
            case "Paralyze" (remove):
            {
                say("This spell renders an enemy immobile for a relatively short duration. The reagents required are spider's silk and nightshade.");
            }
            case "Peer" (remove):
            {
                say("This spell gives the mage a look at the entire world as well as showing his location in it. The reagents required are mandrake root and nightshade.");
            }
            case "Poison" (remove):
            {
                say("This spell enables you to introduce toxins into your opponent's body. The reagents required are black pearl, blood moss, and nightshade");
            }
            case "Protect all" (remove):
            {
                say("This spell is a more advanced version of protection, affecting all members of the caster's troupe. The reagents required are garlic, ginseng, and mandrake root.");
            }
            case "Sleep" (remove):
            {
                say("This spell spell puts the affected into a deep slumber for a short period of time.");
            }
            case "Swarm" (remove):
            {
                say("This spell causes swarms of insects to attack the enemies of the mage from all directions. The reagents required are blood moss, mandrake root, and nightshade.");
            }
// 4th
            case "Conjure" (remove):
            {
                say("This spell summons a wild beast that will fight for the mage against any enemy. The reagents required are mandrake root and spider's silk.");
            }
            case "Lightning" (remove):
            {
                say("This spell enables the mage to cast a bolt of lightning that will strike his target. This lightning is so destructive that no armor can protect its wearer from it. The reagents required are black pearl, mandrake root, and sulfurous ash.");
            }
            case "Mark" (remove):
            {
                say("This spell creates a magical \"mark\" on any of eight specific colored stones to store your present location for the recall spell. The reagents required are black pearl, blood moss, and mandrake root.");
            }
            case "Mass Curse" (remove):
            {
                say("This spell is a more powerful version of the curse spell and affects all opposing creatures present. The reagents required are garlic, mandrake root, nightshade, and sulfurous ash.");
            }
            case "Recall" (remove):
            {
                say("Casting this spell on a marked stone takes the mage and his party back to where the mark spell was cast on that stone. The reagents required are black pearl, blood moss, and mandrake root.");
            }
            case "Reveal" (remove):
            {
                say("This spell makes visible all things that were invisible within a specific area. The reagents required are blood moss and sulfurous ash.");
            }
            case "Seance" (remove):
            {
                say("This spell allows the mage to speak to all recently deceased ghosts. The reagents required are blood moss, mandrake root, nightshade, spider's silk, and sulfurous ash.");
            }
            case "Unlock magic" (remove):
            {
                say("This spell unlocks magically locked items. The reagents required are blood moss and sulfurous ash.");
            }
// 5th
            case "Charm" (remove):
            {
                say("This spell can be used to either ensorcell an enemy or creature into doing the mage's bidding. The reagents required are black pearl, nightshade, and spider's silk.");
            }
            case "Dance" (remove):
            {
                say("This spell makes everyone in sight (except the mage and his party) start to dance. The reagents required are blood moss, garlic, and mandrake root.");
            }
            case "Dispel field" (remove):
            {
                say("This spell can dispel any type of magical field. The reagents required are black pearl, garlic, spider's silk, and sulfurous ash.");
            }
            case "Explosion" (remove):
            {
                say("This spell creates a ball of flame that rushes towards the mage's intended target and explodes. The reagents required are black pearl, blood moss, mandrake root, and sulfurous ash.");
            }
            case "Fire field" (remove):
            {
                say("This spell creates a wall of fire between the mage and his enemies. The reagents required are black pearl, spider's silk, and sulfurous ash.");
            }
            case "Great heal" (remove):
            {
                say("This spell completely heals an injured person. The reagents required are garlic, ginseng, mandrake root, and spider's silk.");
            }
            case "Invisibility" (remove):
            {
                say("This spell renders the mage undetectable, not only from sight but to all means of normal detection. The reagents required are blood moss and nightshade.");
            }
            case "Mass sleep" (remove):
            {
                say("This spell puts to sleep a group of targets that are not in the mage's party. The reagents required are ginseng, nightshade, and spider's silk.");
            }
// 6th
            case "Cause fear" (remove):
            {
                say("This spell causes a wave of fear that each man and creature who is not in the mage's party might flee as if in danger of death. The reagents required are garlic, mandrake root, and nightshade.");
            }
            case "Clone" (remove):
            {
                say("This spell creates an exact duplicate of any mortal creature who will fight for the caster. The reagents required are blood moss, ginseng, mandrake root, nightshade, spider's silk, and sulfurous ash.");
            }
            case "Fire ring" (remove):
            {
                say("This spell creates a ring of fire that will encircle the mage's target. The reagents required are black pearl, mandrake root, spider's silk, and sulfurous ash.");
            }
            case "Flame strike" (remove):
            {
                say("This spell creates a field of fire at the feet of all the mage's enemies that are within sight. The reagents required are black pearl, blood moss, and sulfurous ash.");
            }
            case "Magic storm" (remove):
            {
                say("This spell creates a swirling storm that will randomly attack the enemies of the mage with bolts of lightning. The reagents required are blood moss, mandrake root, nightshade, and sulfurous ash.");
            }
            case "Poison field" (remove):
            {
                say("This spell creates a field of energy that will poison all who come into contact with it. The reagents required are black pearl, nightshade, and spider's silk.");
            }
            case "Sleep field" (remove):
            {
                say("This spell creates a thick wall of energy where the mage desires. All who enter this field will fall asleep. The reagents required are black pearl, ginseng, and spider's silk.");
            }
            case "Tremor" (remove):
            {
                say("This spell creates violent tremors in the earth that will cause the mage's enemies to tremble frantically. The reagents required are blood moss, mandrake root, and sulfurous ash.");
            }
// 7th
            case "Create gold" (remove):
            {
                say("This spell changes a chunk of lead into ten gold nuggets. The reagents required are mandrake root and spider's silk.");
            }
            case "Death bolt" (remove):
            {
                say("This spell enables the mage to project a bolt of lethal energy at a specific target. The reagents required are black pearl, nightshade, and sulfurous ash.");
            }
            case "Delayed blast" (remove):
            {
                say("This spell causes whatever it is cast upon to violently explode within a few seconds, destroying much of the surrounding area. The reagents required are black pearl, blood moss, mandrake root, spider's silk, and sulfurous ash.");
            }
            case "Energy field" (remove):
            {
                say("This spell creates an impenetrable field of electrical energy. The reagents required are black pearl, mandrake root, spider's silk, and sulfurous ash.");
            }
            case "Energy mist" (remove):
            {
                say("This spell causes an electrified mist that flows from the caster, enveloping his enemies and harming them as long as they remain within it. The reagents required are blood moss, mandrake root, nightshade, and sulfurous ash.");
            }
            case "Mass charm" (remove):
            {
                say("This spell causes a group of he mage's enemies to change sides in battle. The reagents required are black pearl, mandrake root, nightshade, and spider's silk.");
            }
            case "Mass might" (remove):
            {
                say("This spell doubles the strength and combat abilities of everyone in the mage's party. The reagents required are black pearl, ginseng, and mandrake root.");
            }
            case "Restoration" (remove):
            {
                say("This spell instantly heals all injury, dispels all harmful magic, and cures all poison or paralysis inflicting the mage and his party. The reagents required are garlic, ginseng, mandrake root, and spider's silk.");
            }
// 8th
            case "Armageddon" (remove):
            {
                say("This spell is believed to be so powerful that it may be capable of destroying all known living things in the entire world. The reagents required are black pearl, blood moss, garlic, ginseng, mandrake root, nightshade, spider's silk, and sulfurous ash.");
            }
            case "Death vortex" (remove):
            {
                say("This spell creates a swirling black vortex at the point the mage designates, which thereafter will move at random. Everyone within this vortex will be continuously struck by lightning. The reagents required are blood moss, mandrake root, nightshade, and sulfurous ash.");
            }
            case "Invisibility all" (remove):
            {
                say("This spell turns the mage and everyone in his party invisible. The reagents required are black pearl, blood moss, mandrake root, and nightshade.");
            }
            case "Mass death" (remove):
            {
                say("This spell causes everyone in sight (except the mage and his party) to instantly drop dead. The reagents required are blood moss, garlic, ginseng, spider's silk, and sulfurous ash.");
            }
            case "Resurrect" (remove):
            {
                say("This spell, when successful, empowers the mage to restore life in one who has died.");
            }
            case "Summon" (remove):
            {
                say("This spell summons a powerful creature that will fight for the mage and his party. The reagents required are blood moss, garlic, and mandrake root.");
            }
            case "Swordstrike" (remove):
            {
                say("This spell creates a deadly pinwheel of eight spinning swords that sail towards the designated target. The reagents required are black pearl, mandrake root, and nightshade.");
            }
            case "Time stop" (remove):
            {
                say("This spell stops the passage of time for the entire world, with the exception of the mage and his party. The reagents required are blood moss, garlic, and mandrake root.");
            }
// Other
            case "Detect Charges" (remove):
            {
                say("This spell shows how many charges a magical item has left until completely drained of power.");
            }
            case "Recharge Magic" (remove):
            {
                say("This spell channels the casters energy and stores it in a failing magical item.");
            }
            case "Add to a spellbook":
            {
                adding_scroll = true;
                break;
            }
            case "Cast from the scroll":
            {
                break;
            }
            case "close scroll":
            {
                return;
            }
        }
        if (adding_scroll)
        {
                script item
                {
                       call &AddScroll, DOUBLECLICK;
                }
        }
        else
        {
                if (UI_get_weather() == 3)  // in magic storm (no spellcasting zone)
                       AVATAR.say("These storms are making the ether too unstable.");
                else
                {
                       var spells = [0x648, &Douse, &Fireworks, &Glimmer, &Help, &Ignite, &Thunder, &Weather,         // Linear
                                     0x672, 0x640, 0x641, 0x642, &GreatDouse, &GreatIgnite, 0x645, &Locate,           // 1nd
                                     0x649, 0x652, &Fire_blast, 0x64C, 0x64E, 0x64F, 0x647, &WizardEye,               // 2rd
                                     0x651, 0x64D, 0x655, &Peer, &Poison, 0x654, 0x656, &Swarm,                       // 3th
                                     0x660, 0x677, &Mark, 0x65C, &Recall, 0x65D, &Seance, 0x65F,                      // 4th
                                     0x668, &Dance, 0x661, &Explosion, &Fire_Field, 0x663, 0x664, 0x665,              // 5th
                                     0x66A, &Clone, 0x66C, 0x66D, &MagicStorm, &Poison_field, &Sleep_field, &Tremor,  // 6th
                                     &Create_gold, &Deathbolt, 0x67A, 0x670, &Energy_Mist, &MassCharm, 0x673, 0x675,  // 7th
                                     &Armageddon, 0x680, 0x682, 0x681, &Resurrect, 0x685, 0x67F, &Time_stop,          // 8th
                                     &Detect_charges, &RechargeMagic];                                                // other
                       for (function in spells with index)
                       {
                                if (quality == index -1 || quality == index + 84 || quality == index + 169)
                                {
                                     script AVATAR
                                     {
                                            call function, DOUBLECLICK;
                                     }
                                     script item
                                     {
                                            wait 4;
                                            remove;
                                     }
                                }
                       }
                }
        }
}