/*
 *
 *  Copyright (C) 2007 Malignant Manor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *	Author: Malignant Manor
 *	Last Modified: 2008-09-11
 */

Conveyer_belt shape#(1086) ()
{
      var pos = get_object_position();
      var find_mining_machine = UI_find_nearby(item, 1177, 2, 0);
      var find_conveyer_belt = UI_find_nearby(item, 1086, 4, 0);
      if (event == 254 && pos[Z] == 1 && gflags[moved_ore] == false)
      {
           if (find_conveyer_belt || find_mining_machine)
                  move_object([pos[X] +1, pos[Y], pos[Z]]);
           else
                  gflags[moved_ore] = true;
      }
      else if (event == 254)
            gflags[moved_ore] = true;
      else if (event == SCRIPTED)
      {
            if (gflags[moved_ore] == false)
                  move_object([pos[X], pos[Y], 0]);
            gflags[using_mining_machine] = false;
            gflags[moved_ore] = false;

      }
      else if (event == 255)
      {
            gflags[using_mining_machine] = false;
            gflags[moved_ore] = false;
      }
}

Mining_machine shape#(1177)()
{
   var ore;
   var offset;
   var quality = get_item_quality();
   var find_conveyer_belt = UI_find_nearby(item, 1086, 10, 0);
   var blackrock = 1055;
   var iron = 1082;
   var lead = 1083;
   var pos = UI_get_object_position(find_conveyer_belt);

   if (gflags[using_mining_machine])
         return;

   if ((quality == 0) || (quality > 3))
   {
         script item
         {
               frame 0;
               frame 1;
               sfx 0x25;
               sfx 0x4C;
         }
         return;
   }
   else
   {
         gflags[using_mining_machine] = true;

         if (UI_get_random(2) == 1)
         {
               script item
               {
                     frame 0;
                     repeat 33
                     {
                           next frame cycle;
                           continue;
                           sfx 0x46;
                     };
                     call Conveyer_belt, 255;
               }
               script find_conveyer_belt
               {
                     frame 0;
                     repeat 31
                     {
                           next frame cycle;
                           continue;
                           sfx 0x46;
                     };
               }
         }
         else
         {
               if (quality == 1)
               {
                     ore = UI_create_new_object2(blackrock, [(pos[X] - 9), pos[Y], 1]);
                     offset = 0;
               }
               else if (quality == 2)
               {
                     ore = UI_create_new_object2(iron, [(pos[X] - 9), pos[Y], 1]);
                     offset = - 1;
               }
               else if (quality == 3)
               {
                     ore = UI_create_new_object2(lead, [(pos[X] - 9), pos[Y], 1]);
                     offset =  - 1;
               }
               UI_set_item_flag(ore, TEMPORARY);
               
               script item
               {
                     frame 0;
                     repeat 33 + offset
                     {
                           next frame cycle;
                           continue;
                           sfx 0x46;
                     };
               }
               script find_conveyer_belt
               {
                     frame 0;
                     repeat 31 + offset
                     {
                           next frame cycle;
                           continue;
                           sfx 0x46;
                     };
               }
               script ore
               {
                     repeat 10 + offset
                     {
                           wait 2;
                           call Conveyer_belt, 254;
                     };
                     call Conveyer_belt, SCRIPTED;
               }
         }
   }
}





/*
Func019A 0x19A (var var0000)
{
	var var0001;
	var var0002;
	var var0003;
	var var0004;
	var var0005;

	if (!(event == 0x0001)) goto labelFunc019A_00C5;
	UI_close_gumps();
	var0000 = UI_find_nearby(item, 0x019B, 0x000A, 0x0000);
	var0001 = UI_get_item_quality(item);
	if (!((var0001 == 0x0000) || (var0001 > 0x0003))) goto labelFunc019A_0059;
	var0002 = UI_execute_usecode_array(item, [0x46, 0x0000, 0x46, 0x0001, 0x58, 0x0025, 0x58, 0x004C]);
	goto labelFunc019A_00C5;
	labelFunc019A_0059:
		var0003 = [0x0392, 0x0394, 0x0393];
		var0004 = var0003[var0001];
		var0002 = UI_execute_usecode_array(item, [0x46, 0x0000, 0x4D, 0x01, 0x58, 0x0008, 0x0C, 0xFFFC, 0x0003, 0x0004, 0x0B, 0xFFF6, 0x0007]);
		var0002 = UI_execute_usecode_array(var0000, [0x46, 0x0000, 0x4E, 0x01, 0x58, 0x000F, 0x55, Create_Ore, 0x0B, 0xFFF9, 0x0018]);
	labelFunc019A_00C5:
		return;
}

Create_Ore ()
{
	var var0000
        var var0001;
	var var0002;
	var var0003;
	var var0004;
	var var0005;
	var var0006;
	var var0007;
	var var0008;
	var var0009;
	var var000A;
	var var000B;
	var var000C;
	var var000D;
	var var000E;
	var var000F;
	var var0010;
	var var0011;
	var var0012;

	if (event == 2)) goto labelFunc060D_0009;
	return;
	labelFunc060D_0009:
		var0000 = UI_find_nearby(item, 0x019A, 10, 0);
		var0001 = UI_get_item_quality(var0000);
		var0002 = [0x0392, 0x0394, 0x0393];
		var0003 = var0002[var0001];
		if (!(UI_die_roll(1, 0x0014) == 1)) goto labelFunc060D_0096;
		var0004 = UI_get_object_position(item);
		var0005 = UI_create_new_object(var0003);
		if (!var0005) goto labelFunc060D_0096;
		UI_set_item_flag(var0005, 18);
		UI_set_item_frame(var0005, 0);
		var0006 = UI_update_last_created([(var0004[1] - 9), var0004[2], 1]);
	labelFunc060D_0096:
		var0007 = UI_find_nearby(item, 0xFE99, 10, 0);
		var0008 = UI_get_object_position(item);
		var0009 = var0008[1];
		var000A = var0008[2];
		//enum();
	labelFunc060D_00C2:
		for (var000D in var0007 with var000B to var000C) atend labelFunc060D_0177;
		var000E = UI_get_object_position(var000D);
		var000F = var000E[1];
		var0010 = var000E[2];
		var0011 = var000E[0x0003];
		if (!((var000F <= var0009) && ((var0010 == var000A) && (var0011 == 1)))) goto labelFunc060D_0133;
		var0006 = UI_set_last_created(var000D);
		if (!var0006) goto labelFunc060D_0133;
		var0006 = UI_update_last_created([(var000F + 1), var0010, var0011]);
	labelFunc060D_0133:
		if (!((var000F == (var0009 + 1)) && ((var0010 == var000A) && (var0011 == 1)))) goto labelFunc060D_0174;
		var0006 = UI_set_last_created(var000D);
		if (!var0006) goto labelFunc060D_0174;
		var0006 = UI_update_last_created([var000F, var0010, 0]);
	labelFunc060D_0174:
		goto labelFunc060D_00C2;
	labelFunc060D_0177:
		return;
}

*/