/*
    Copyright (C) 2007 Malignant Manor

    This file is part of SI BG Merge.

    SI BG Merge is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    SI BG Merge is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SI BG Merge.  If not, see <http://www.gnu.org/licenses/>.

    Author: Malignant Manor
    Last Modified: 2008-09-11
*/

/*      set when reading a scroll
        BenSignedScroll    = 1500
        RunebClue          = 1501
        ReadYewCourtBook   = 1502 //was 0x0126
        ReadYewCourtBook2  = 1503 //was 0x0159
        ReadVenomLedger    = 1504 //was 0x0233
        ReadStoneCastambre = 1505
*/
const int SeanceCast       = 1506;
const int ArmageddonCast   = 1507;

//Tseramed
const int DECIEVED_TSERAMED = 1518;
const int KNOW_TSERAMEDS_JOB = 1519;
const int asked_to_talk_before = 1520;
const int Tseramed_asked_to_join = 1521;
const int TSERAMED_TALKED_ABOUT_COMBAT = 1522;

//Fortune teller conversation ~ also uses "AvatarIs" flags
const int StartTest =          1523;
const int DeniedCompassion =   1524;
const int DeniedHonesty =      1525;
const int DeniedHonor =        1526;
const int DeniedHumility =     1527;
const int DeniedJustice =      1528;
const int DeniedSacrifice =    1529;
const int DeniedSpirituality = 1530;
const int DeniedValor =        1531;
const int Compassion1 =        1532;
const int Honesty1 =           1533;
const int Honor1 =             1534;
const int Humility1 =          1535;
const int Justice1 =           1536;
const int Sacrifice1 =         1537;
const int Spirituality1 =      1538;
const int Valor1 =             1539;
const int Compassion2 =        1540;
const int Honesty2 =           1541;
const int Honor2 =             1542;
const int Humility2 =          1543;
const int Justice2 =           1544;
const int Sacrifice2 =         1545;
const int Spirituality2 =      1546;
const int Valor2 =             1547;
const int FindWagon =          1548;

const int using_mining_machine = 1550;
const int moved_ore = 1551;
const int can_have_stoneheart = 1552;

enum spell_flags
{
        AvatarIsBard     = 1508,
        AvatarIsRanger   = 1509,
        AvatarIsPaladin  = 1510,
        AvatarIsDruid    = 1511,
        AvatarIsMage     = 1512,
        AvatarIsFighter  = 1513,
        AvatarIsTinker   = 1514,
        AvatarIsShepherd = 1599,

        SET_IOLO_MANA    = 1515,
        SET_SHAMINO_MANA = 1516,
        SET_DUPRE_MANA   = 1517,
        SET_GWENNO_MANA  = 1549,
        WIZARD_MODE      = 1600,

        //Linear Spells

        AWAKEN           = 1601,
        DOUSE            = 1602,
        FIREWORKS        = 1603,
        GLIMMER          = 1604,
        HELP             = 1605,
        IGNITE           = 1606,
        THUNDER          = 1607,
        WEATHER          = 1608,

        //First Circle

        AWAKEN_ALL       = 1609,
        CREATE_FOOD      = 1610,
        CURE             = 1611,
        DETECT_TRAP      = 1612,
        GREAT_DOUSE      = 1613,
        GREAT_IGNITE     = 1614,
        LIGHT            = 1615,
        LOCATE           = 1616,

 
        //Second Circle

        DESTROY_TRAP     = 1617,
        ENCHANT          = 1618,
        FIRE_BLAST       = 1619,
        GREAT_LIGHT      = 1620,
        MASS_CURE        = 1621,
        PROTECTION_SPELL = 1622,
        TELEKINESIS      = 1623,
        WIZARD_EYE       = 1624,

        //Third Circle
 
        CURSE            = 1625,
        HEAL             = 1626,
        PARALYSE         = 1627,
        PEER             = 1628,
        POISON           = 1629,
        PROTECT_ALL      = 1630,
        SLEEP_SPELL      = 1631,
        SWARM            = 1632,

        //Fourth Circle
 
        CONJURE          = 1633,
        LIGHTNING        = 1634,
        MARK             = 1635,
        MASS_CURSE       = 1636,
        RECALL           = 1637,
        REVEAL           = 1638,
        SEANCE           = 1639,
        UNLOCK_MAGIC     = 1640,

        //Fifth Circle

        CHARM            = 1641,
        DANCE_SPELL      = 1642,
        DISPEL_FIELD     = 1643,
        EXPLOSION        = 1644,
        FIRE_FIELD       = 1645,
        GREAT_HEAL       = 1646,
        INVISIBILITY     = 1647,
        MASS_SLEEP       = 1648,

        //Sixth Circle
 
        CAUSE_FEAR       = 1649,
        CLONE            = 1650,
        FIRE_RING        = 1651,
        FLAME_STRIKE     = 1652,
        MAGIC_STORM      = 1653,
        POISON_FIELD     = 1654,
        SLEEP_FIELD      = 1655,
        TREMOR           = 1656,

        //Seventh Circle
 
        CREATE_GOLD      = 1657,
        DEATH_BOLT       = 1658,
        DELAYED_BLAST    = 1659,
        ENERGY_FIELD     = 1660,
        ENERGY_MIST      = 1661,
        MASS_CHARM       = 1662,
        MASS_MIGHT       = 1663,
        RESTORATION      = 1664,

        //Eighth Circle

        ARMAGEDDON       = 1665,
        DEATH_VORTEX     = 1666,
        INVISIBILITY_All = 1667,
        MASS_DEATH       = 1668,
        RESURRECT        = 1669,
        SUMMON           = 1670,
        SWORDSTRIKE      = 1671,
        TIME_STOP        = 1672,
        
        //Spellbook 2
        
        //Linear Spells

        AWAKEN2          = 1701,
        DOUSE2           = 1702,
        FIREWORKS2       = 1703,
        GLIMMER2         = 1704,
        HELP2            = 1705,
        IGNITE2          = 1706,
        THUNDER2         = 1707,
        WEATHER2         = 1708,

        //First Circle

        AWAKEN_ALL2      = 1709,
        CREATE_FOOD2     = 1710,
        CURE2            = 1711,
        DETECT_TRAP2     = 1712,
        GREAT_DOUSE2     = 1713,
        GREAT_IGNITE2    = 1714,
        LIGHT2           = 1715,
        LOCATE2          = 1716,

 
        //Second Circle

        DESTROY_TRAP2    = 1717,
        ENCHANT2         = 1718,
        FIRE_BLAST2      = 1719,
        GREAT_LIGHT2     = 1720,
        MASS_CURE2       = 1721,
        PROTECTION_SPELL2 = 1722,
        TELEKINESIS2     = 1723,
        WIZARD_EYE2      = 1724,

        //Third Circle
 
        CURSE2           = 1725,
        HEAL2            = 1726,
        PARALYSE2        = 1727,
        PEER2            = 1728,
        POISON2          = 1729,
        PROTECT_ALL2     = 1730,
        SLEEP_SPELL2     = 1731,
        SWARM2           = 1732,

        //Fourth Circle
 
        CONJURE2         = 1733,
        LIGHTNING2       = 1734,
        MARK2            = 1735,
        MASS_CURSE2      = 1736,
        RECALL2          = 1737,
        REVEAL2          = 1738,
        SEANCE2          = 1739,
        UNLOCK_MAGIC2    = 1740,

        //Fifth Circle

        CHARM2           = 1741,
        DANCE_SPELL2     = 1742,
        DISPEL_FIELD2    = 1743,
        EXPLOSION2       = 1744,
        FIRE_FIELD2      = 1745,
        GREAT_HEAL2      = 1746,
        INVISIBILITY2    = 1747,
        MASS_SLEEP2      = 1748,

        //Sixth Circle
 
        CAUSE_FEAR2      = 1749,
        CLONE2           = 1750,
        FIRE_RING2       = 1751,
        FLAME_STRIKE2    = 1752,
        MAGIC_STORM2     = 1753,
        POISON_FIELD2    = 1754,
        SLEEP_FIELD2     = 1755,
        TREMOR2          = 1756,

        //Seventh Circle
 
        CREATE_GOLD2     = 1757,
        DEATH_BOLT2      = 1758,
        DELAYED_BLAST2   = 1759,
        ENERGY_FIELD2    = 1760,
        ENERGY_MIST2     = 1761,
        MASS_CHARM2      = 1762,
        MASS_MIGHT2      = 1763,
        RESTORATION2     = 1764,

        //Eighth Circle

        ARMAGEDDON2      = 1765,
        DEATH_VORTEX2    = 1766,
        INVISIBILITY_All2 = 1767,
        MASS_DEATH2      = 1768,
        RESURRECT2       = 1769,
        SUMMON2          = 1770,
        SWORDSTRIKE2     = 1771,
        TIME_STOP2       = 1772
};
